import { world, ItemStack, BlockPermutation } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
        initEvent.blockComponentRegistry.registerCustomComponent('true:mulch_growth', {
        onPlayerInteract: eventData => {
            const block = eventData.block
            const player = eventData.player
            const blockLocation = block.location;
            const blockPos = block.location;
            const item = eventData.player.getComponent('equippable').getEquipment('Mainhand')
            if (item?.typeId == "true:growth_mulch" && block.permutation.getState('true:stage') < 4) {
                block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') + 1))
                player.runCommandAsync(`particle minecraft:crop_growth_emitter ${blockPos.x} ${blockPos.y + 1} ${blockPos.z}`);
                player.runCommandAsync(`clear @s true:growth_mulch 0 1`);
            }
          }
        }
      )
    }
  );
  world.beforeEvents.worldInitialize.subscribe(initEvent => {
        initEvent.blockComponentRegistry.registerCustomComponent('true:mulch_gooey', {
        onPlayerInteract: eventData => {
            const block = eventData.block
            const player = eventData.player
            const blockLocation = block.location;
            const blockPos = block.location;
            const item = eventData.player.getComponent('equippable').getEquipment('Mainhand')
            if (item?.typeId == "true:gooey_mulch" && block.permutation.getState('true:stage') < 4) {
                block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') + 2))
                player.runCommandAsync(`particle minecraft:crop_growth_emitter ${blockPos.x} ${blockPos.y + 1} ${blockPos.z}`);
                player.runCommandAsync(`clear @s true:gooey_mulch 0 1`);
            }
          }
        }
      )
    }
  );
  world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('true:collect', {
    onPlayerInteract: eventData => {
        const block = eventData.block
        const player = eventData.player
        const blockLocation = block.location;
        const blockPos = block.location;
        if (block.typeId == "true:apricorn_tree_white" && block.permutation.getState('true:stage') == 5) {
              block.dimension.playSound("apricorn_collection", blockLocation, { pitch: 1.0, volume: 1.0 });
              block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 1))
              block.dimension.runCommandAsync(`loot spawn ${blockLocation.x + 0.5} ${blockLocation.y + 1.0} ${blockLocation.z + 0.5} loot "blocks/apricorn_trees/white"`);
            }
            if (block.typeId == "true:apricorn_tree_black" && block.permutation.getState('true:stage') == 5) {
              block.dimension.playSound("apricorn_collection", blockLocation, { pitch: 1.0, volume: 1.0 });
              block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 1))
              block.dimension.runCommandAsync(`loot spawn ${blockLocation.x + 0.5} ${blockLocation.y + 1.0} ${blockLocation.z + 0.5} loot "blocks/apricorn_trees/black"`);
            }
            if (block.typeId == "true:apricorn_tree_red" && block.permutation.getState('true:stage') == 5) {
              block.dimension.playSound("apricorn_collection", blockLocation, { pitch: 1.0, volume: 1.0 });
              block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 1))
              block.dimension.runCommandAsync(`loot spawn ${blockLocation.x + 0.5} ${blockLocation.y + 1.0} ${blockLocation.z + 0.5} loot "blocks/apricorn_trees/red"`);
            }
            if (block.typeId == "true:apricorn_tree_blue" && block.permutation.getState('true:stage') == 5) {
              block.dimension.playSound("apricorn_collection", blockLocation, { pitch: 1.0, volume: 1.0 });
              block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 1))
              block.dimension.runCommandAsync(`loot spawn ${blockLocation.x + 0.5} ${blockLocation.y + 1.0} ${blockLocation.z + 0.5} loot "blocks/apricorn_trees/blue"`);
            }
            if (block.typeId == "true:apricorn_tree_yellow" && block.permutation.getState('true:stage') == 5) {
              block.dimension.playSound("apricorn_collection", blockLocation, { pitch: 1.0, volume: 1.0 });
              block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 1))
              block.dimension.runCommandAsync(`loot spawn ${blockLocation.x + 0.5} ${blockLocation.y + 1.0} ${blockLocation.z + 0.5} loot "blocks/apricorn_trees/yellow"`);
            }
            if (block.typeId == "true:apricorn_tree_green" && block.permutation.getState('true:stage') == 5) {
              block.dimension.playSound("apricorn_collection", blockLocation, { pitch: 1.0, volume: 1.0 });
              block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 1))
              block.dimension.runCommandAsync(`loot spawn ${blockLocation.x + 0.5} ${blockLocation.y + 1.0} ${blockLocation.z + 0.5} loot "blocks/apricorn_trees/green"`);
            }
          }
        }
      )
    }
 );
 world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('true:growth', {
        onTick(e) {
            const { block } = e
            const age = block.permutation.getState('true:stage')
            if (age < 5) {
                block.setPermutation(block.permutation.withState('true:stage', age + 1))
            }
          }
        }
      )
    }  
  )
 //SPAWN BLOCKS
  world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('true:spawn_pokestop', {
        onTick(e) {
            const { block } = e
            const blockLocation = block.location;
              e.block.setPermutation(BlockPermutation.resolve("minecraft:air"));
              block.dimension.runCommandAsync(`summon true:pokestop ${blockLocation.x} ${blockLocation.y} ${blockLocation.z}`);
         
          }
        }
      )
   eventData.blockComponentRegistry.registerCustomComponent('true:spawn_pokegym', {
        onTick(e) {
            const { block } = e
            const blockLocation = block.location;
              e.block.setPermutation(BlockPermutation.resolve("minecraft:air"));
              block.dimension.runCommandAsync(`summon true:pokegym ${blockLocation.x} ${blockLocation.y} ${blockLocation.z}`);
         
          }
        }
      )
    }  
  )