import { system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";

//bulbasaur
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("bulbasaur_interact")){
            bulbasaur_interact(player)
			player.removeTag("bulbasaur_interact")
		}
  }
  function bulbasaur_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_bulbasaur(player)
        }
        if (result.selection === 1) {
            return_bulbasaur(player)
        }
        if (result.selection === 2) {
            follow_bulbasaur(player)
        }
        if (result.selection === 3) {
            evolve_bulbasaur(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_bulbasaur(player) {
    player.runCommandAsync("event entity @e [family=bulbasaur,c=1,r=5] true:to_fight");
}
function return_bulbasaur(player) {
    player.runCommandAsync("event entity @e [family=bulbasaur,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:bulbasaur_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_bulbasaur(player) {
    player.runCommandAsync("event entity @e [family=bulbasaur,c=1,r=5] true:to_follow");
}
function evolve_bulbasaur (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=bulbasaur,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//bulbasaur fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("bulbasaur_fainted")){
            bulbasaur_fainted(player)
			player.removeTag("bulbasaur_fainted")
		}
  }
  function bulbasaur_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_bulbasaur_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_bulbasaur_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:bulbasaur_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:bulbasaur_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//bulbasaur shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("bulbasaur_s_interact")){
            bulbasaur_s_interact(player)
			player.removeTag("bulbasaur_s_interact")
		}
  }
  function bulbasaur_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_bulbasaur_s(player)
        }
        if (result.selection === 1) {
            return_bulbasaur_s(player)
        }
        if (result.selection === 2) {
            follow_bulbasaur_s(player)
        }
        if (result.selection === 3) {
            evolve_bulbasaur_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_bulbasaur_s(player) {
    player.runCommandAsync("event entity @e [family=bulbasaur_s,c=1,r=5] true:to_fight");
}
function return_bulbasaur_s(player) {
    player.runCommandAsync("event entity @e [family=bulbasaur_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:bulbasaur_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_bulbasaur_s(player) {
    player.runCommandAsync("event entity @e [family=bulbasaur_s,c=1,r=5] true:to_follow");
}
function evolve_bulbasaur_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=bulbasaur_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//bulbasaur shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("bulbasaur_s_fainted")){
            bulbasaur_s_fainted(player)
			player.removeTag("bulbasaur_s_fainted")
		}
  }
  function bulbasaur_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_bulbasaur_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_bulbasaur_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:bulbasaur_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:bulbasaur_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ivysaur
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ivysaur_interact")){
            ivysaur_interact(player)
			player.removeTag("ivysaur_interact")
		}
  }
  function ivysaur_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_ivysaur(player)
        }
        if (result.selection === 1) {
            return_ivysaur(player)
        }
        if (result.selection === 2) {
            follow_ivysaur(player)
        }
        if (result.selection === 3) {
            evolve_ivysaur(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_ivysaur(player) {
    player.runCommandAsync("event entity @e [family=ivysaur,c=1,r=5] true:to_fight");
}
function return_ivysaur(player) {
    player.runCommandAsync("event entity @e [family=ivysaur,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ivysaur_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_ivysaur(player) {
    player.runCommandAsync("event entity @e [family=ivysaur,c=1,r=5] true:to_follow");
}
function evolve_ivysaur (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=ivysaur,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ivysaur fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ivysaur_fainted")){
            ivysaur_fainted(player)
			player.removeTag("ivysaur_fainted")
		}
  }
  function ivysaur_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_ivysaur_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_ivysaur_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:ivysaur_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ivysaur_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ivysaur shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ivysaur_s_interact")){
            ivysaur_s_interact(player)
			player.removeTag("ivysaur_s_interact")
		}
  }
  function ivysaur_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_ivysaur_s(player)
        }
        if (result.selection === 1) {
            return_ivysaur_s(player)
        }
        if (result.selection === 2) {
            follow_ivysaur_s(player)
        }
        if (result.selection === 3) {
            evolve_ivysaur_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_ivysaur_s(player) {
    player.runCommandAsync("event entity @e [family=ivysaur_s,c=1,r=5] true:to_fight");
}
function return_ivysaur_s(player) {
    player.runCommandAsync("event entity @e [family=ivysaur_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ivysaur_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_ivysaur_s(player) {
    player.runCommandAsync("event entity @e [family=ivysaur_s,c=1,r=5] true:to_follow");
}
function evolve_ivysaur_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=ivysaur_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ivysaur shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ivysaur_s_fainted")){
            ivysaur_s_fainted(player)
			player.removeTag("ivysaur_s_fainted")
		}
  }
  function ivysaur_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_ivysaur_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_ivysaur_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:ivysaur_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ivysaur_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//venusaur
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("venusaur_interact")){
            venusaur_interact(player)
			player.removeTag("venusaur_interact")
		}
  }
  function venusaur_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_venusaur(player)
        }
        if (result.selection === 1) {
            return_venusaur(player)
        }
        if (result.selection === 2) {
            follow_venusaur(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_venusaur(player) {
    player.runCommandAsync("event entity @e [family=venusaur,c=1,r=5] true:to_fight");
}
function return_venusaur(player) {
    player.runCommandAsync("event entity @e [family=venusaur,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:venusaur_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_venusaur(player) {
    player.runCommandAsync("event entity @e [family=venusaur,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//venusaur fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("venusaur_fainted")){
            venusaur_fainted(player)
			player.removeTag("venusaur_fainted")
		}
  }
  function venusaur_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_venusaur_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_venusaur_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:venusaur_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:venusaur_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//venusaur shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("venusaur_s_interact")){
            venusaur_s_interact(player)
			player.removeTag("venusaur_s_interact")
		}
  }
  function venusaur_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_venusaur_s(player)
        }
        if (result.selection === 1) {
            return_venusaur_s(player)
        }
        if (result.selection === 2) {
            follow_venusaur_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_venusaur_s(player) {
    player.runCommandAsync("event entity @e [family=venusaur_s,c=1,r=5] true:to_fight");
}
function return_venusaur_s(player) {
    player.runCommandAsync("event entity @e [family=venusaur_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:venusaur_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_venusaur_s(player) {
    player.runCommandAsync("event entity @e [family=venusaur_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//venusaur shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("venusaur_s_fainted")){
            venusaur_s_fainted(player)
			player.removeTag("venusaur_s_fainted")
		}
  }
  function venusaur_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_venusaur_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_venusaur_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:venusaur_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:venusaur_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//charmander
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("charmander_interact")){
            charmander_interact(player)
			player.removeTag("charmander_interact")
		}
  }
  function charmander_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_charmander(player)
        }
        if (result.selection === 1) {
            return_charmander(player)
        }
        if (result.selection === 2) {
            follow_charmander(player)
        }
        if (result.selection === 3) {
            evolve_charmander(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_charmander(player) {
    player.runCommandAsync("event entity @e [family=charmander,c=1,r=5] true:to_fight");
}
function return_charmander(player) {
    player.runCommandAsync("event entity @e [family=charmander,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:charmander_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_charmander(player) {
    player.runCommandAsync("event entity @e [family=charmander,c=1,r=5] true:to_follow");
}
function evolve_charmander (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=charmander,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//charmander fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("charmander_fainted")){
            charmander_fainted(player)
			player.removeTag("charmander_fainted")
		}
  }
  function charmander_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_charmander_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_charmander_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:charmander_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:charmander_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//charmander shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("charmander_s_interact")){
            charmander_s_interact(player)
			player.removeTag("charmander_s_interact")
		}
  }
  function charmander_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_charmander_s(player)
        }
        if (result.selection === 1) {
            return_charmander_s(player)
        }
        if (result.selection === 2) {
            follow_charmander_s(player)
        }
        if (result.selection === 3) {
            evolve_charmander_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_charmander_s(player) {
    player.runCommandAsync("event entity @e [family=charmander_s,c=1,r=5] true:to_fight");
}
function return_charmander_s(player) {
    player.runCommandAsync("event entity @e [family=charmander_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:charmander_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_charmander_s(player) {
    player.runCommandAsync("event entity @e [family=charmander_s,c=1,r=5] true:to_follow");
}
function evolve_charmander_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=charmander_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//charmander shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("charmander_s_fainted")){
            charmander_s_fainted(player)
			player.removeTag("charmander_s_fainted")
		}
  }
  function charmander_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_charmander_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_charmander_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:charmander_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:charmander_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//charmeleon
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("charmeleon_interact")){
            charmeleon_interact(player)
			player.removeTag("charmeleon_interact")
		}
  }
  function charmeleon_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_charmeleon(player)
        }
        if (result.selection === 1) {
            return_charmeleon(player)
        }
        if (result.selection === 2) {
            follow_charmeleon(player)
        }
        if (result.selection === 3) {
            evolve_charmeleon(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_charmeleon(player) {
    player.runCommandAsync("event entity @e [family=charmeleon,c=1,r=5] true:to_fight");
}
function return_charmeleon(player) {
    player.runCommandAsync("event entity @e [family=charmeleon,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:charmeleon_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_charmeleon(player) {
    player.runCommandAsync("event entity @e [family=charmeleon,c=1,r=5] true:to_follow");
}
function evolve_charmeleon (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=charmeleon,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//charmeleon fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("charmeleon_fainted")){
            charmeleon_fainted(player)
			player.removeTag("charmeleon_fainted")
		}
  }
  function charmeleon_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_charmeleon_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_charmeleon_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:charmeleon_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:charmeleon_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//charmeleon shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("charmeleon_s_interact")){
            charmeleon_s_interact(player)
			player.removeTag("charmeleon_s_interact")
		}
  }
  function charmeleon_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_charmeleon_s(player)
        }
        if (result.selection === 1) {
            return_charmeleon_s(player)
        }
        if (result.selection === 2) {
            follow_charmeleon_s(player)
        }
        if (result.selection === 3) {
            evolve_charmeleon_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_charmeleon_s(player) {
    player.runCommandAsync("event entity @e [family=charmeleon_s,c=1,r=5] true:to_fight");
}
function return_charmeleon_s(player) {
    player.runCommandAsync("event entity @e [family=charmeleon_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:charmeleon_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_charmeleon_s(player) {
    player.runCommandAsync("event entity @e [family=charmeleon_s,c=1,r=5] true:to_follow");
}
function evolve_charmeleon_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=charmeleon_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//charmeleon shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("charmeleon_s_fainted")){
            charmeleon_s_fainted(player)
			player.removeTag("charmeleon_s_fainted")
		}
  }
  function charmeleon_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_charmeleon_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_charmeleon_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:charmeleon_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:charmeleon_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//charizard
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("charizard_interact")){
            charizard_interact(player)
			player.removeTag("charizard_interact")
		}
  }
  function charizard_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_charizard(player)
        }
        if (result.selection === 1) {
            return_charizard(player)
        }
        if (result.selection === 2) {
            follow_charizard(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_charizard(player) {
    player.runCommandAsync("event entity @e [family=charizard,c=1,r=5] true:to_fight");
}
function return_charizard(player) {
    player.runCommandAsync("event entity @e [family=charizard,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:charizard_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_charizard(player) {
    player.runCommandAsync("event entity @e [family=charizard,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//charizard fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("charizard_fainted")){
            charizard_fainted(player)
			player.removeTag("charizard_fainted")
		}
  }
  function charizard_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_charizard_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_charizard_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:charizard_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:charizard_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//charizard shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("charizard_s_interact")){
            charizard_s_interact(player)
			player.removeTag("charizard_s_interact")
		}
  }
  function charizard_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_charizard_s(player)
        }
        if (result.selection === 1) {
            return_charizard_s(player)
        }
        if (result.selection === 2) {
            follow_charizard_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_charizard_s(player) {
    player.runCommandAsync("event entity @e [family=charizard_s,c=1,r=5] true:to_fight");
}
function return_charizard_s(player) {
    player.runCommandAsync("event entity @e [family=charizard_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:charizard_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_charizard_s(player) {
    player.runCommandAsync("event entity @e [family=charizard_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//charizard shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("charizard_s_fainted")){
            charizard_s_fainted(player)
			player.removeTag("charizard_s_fainted")
		}
  }
  function charizard_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_charizard_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_charizard_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:charizard_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:charizard_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//squirtle
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("squirtle_interact")){
            squirtle_interact(player)
			player.removeTag("squirtle_interact")
		}
  }
  function squirtle_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_squirtle(player)
        }
        if (result.selection === 1) {
            return_squirtle(player)
        }
        if (result.selection === 2) {
            follow_squirtle(player)
        }
        if (result.selection === 3) {
            evolve_squirtle(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_squirtle(player) {
    player.runCommandAsync("event entity @e [family=squirtle,c=1,r=5] true:to_fight");
}
function return_squirtle(player) {
    player.runCommandAsync("event entity @e [family=squirtle,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:squirtle_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_squirtle(player) {
    player.runCommandAsync("event entity @e [family=squirtle,c=1,r=5] true:to_follow");
}
function evolve_squirtle (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=squirtle,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//squirtle fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("squirtle_fainted")){
            squirtle_fainted(player)
			player.removeTag("squirtle_fainted")
		}
  }
  function squirtle_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_squirtle_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_squirtle_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:squirtle_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:squirtle_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//squirtle shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("squirtle_s_interact")){
            squirtle_s_interact(player)
			player.removeTag("squirtle_s_interact")
		}
  }
  function squirtle_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_squirtle_s(player)
        }
        if (result.selection === 1) {
            return_squirtle_s(player)
        }
        if (result.selection === 2) {
            follow_squirtle_s(player)
        }
        if (result.selection === 3) {
            evolve_squirtle_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_squirtle_s(player) {
    player.runCommandAsync("event entity @e [family=squirtle_s,c=1,r=5] true:to_fight");
}
function return_squirtle_s(player) {
    player.runCommandAsync("event entity @e [family=squirtle_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:squirtle_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_squirtle_s(player) {
    player.runCommandAsync("event entity @e [family=squirtle_s,c=1,r=5] true:to_follow");
}
function evolve_squirtle_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=squirtle_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//squirtle shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("squirtle_s_fainted")){
            squirtle_s_fainted(player)
			player.removeTag("squirtle_s_fainted")
		}
  }
  function squirtle_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_squirtle_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_squirtle_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:squirtle_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:squirtle_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//wartortle
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("wartortle_interact")){
            wartortle_interact(player)
			player.removeTag("wartortle_interact")
		}
  }
  function wartortle_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_wartortle(player)
        }
        if (result.selection === 1) {
            return_wartortle(player)
        }
        if (result.selection === 2) {
            follow_wartortle(player)
        }
        if (result.selection === 3) {
            evolve_wartortle(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_wartortle(player) {
    player.runCommandAsync("event entity @e [family=wartortle,c=1,r=5] true:to_fight");
}
function return_wartortle(player) {
    player.runCommandAsync("event entity @e [family=wartortle,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:wartortle_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_wartortle(player) {
    player.runCommandAsync("event entity @e [family=wartortle,c=1,r=5] true:to_follow");
}
function evolve_wartortle (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=wartortle,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//wartortle fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("wartortle_fainted")){
            wartortle_fainted(player)
			player.removeTag("wartortle_fainted")
		}
  }
  function wartortle_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_wartortle_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_wartortle_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:wartortle_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:wartortle_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//wartortle shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("wartortle_s_interact")){
            wartortle_s_interact(player)
			player.removeTag("wartortle_s_interact")
		}
  }
  function wartortle_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_wartortle_s(player)
        }
        if (result.selection === 1) {
            return_wartortle_s(player)
        }
        if (result.selection === 2) {
            follow_wartortle_s(player)
        }
        if (result.selection === 3) {
            evolve_wartortle_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_wartortle_s(player) {
    player.runCommandAsync("event entity @e [family=wartortle_s,c=1,r=5] true:to_fight");
}
function return_wartortle_s(player) {
    player.runCommandAsync("event entity @e [family=wartortle_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:wartortle_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_wartortle_s(player) {
    player.runCommandAsync("event entity @e [family=wartortle_s,c=1,r=5] true:to_follow");
}
function evolve_wartortle_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=wartortle_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//wartortle shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("wartortle_s_fainted")){
            wartortle_s_fainted(player)
			player.removeTag("wartortle_s_fainted")
		}
  }
  function wartortle_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_wartortle_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_wartortle_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:wartortle_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:wartortle_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//blastoise
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("blastoise_interact")){
            blastoise_interact(player)
			player.removeTag("blastoise_interact")
		}
  }
  function blastoise_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_blastoise(player)
        }
        if (result.selection === 1) {
            return_blastoise(player)
        }
        if (result.selection === 2) {
            follow_blastoise(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_blastoise(player) {
    player.runCommandAsync("event entity @e [family=blastoise,c=1,r=5] true:to_fight");
}
function return_blastoise(player) {
    player.runCommandAsync("event entity @e [family=blastoise,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:blastoise_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_blastoise(player) {
    player.runCommandAsync("event entity @e [family=blastoise,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//blastoise fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("blastoise_fainted")){
            blastoise_fainted(player)
			player.removeTag("blastoise_fainted")
		}
  }
  function blastoise_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_blastoise_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_blastoise_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:blastoise_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:blastoise_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//blastoise shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("blastoise_s_interact")){
            blastoise_s_interact(player)
			player.removeTag("blastoise_s_interact")
		}
  }
  function blastoise_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_blastoise_s(player)
        }
        if (result.selection === 1) {
            return_blastoise_s(player)
        }
        if (result.selection === 2) {
            follow_blastoise_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_blastoise_s(player) {
    player.runCommandAsync("event entity @e [family=blastoise_s,c=1,r=5] true:to_fight");
}
function return_blastoise_s(player) {
    player.runCommandAsync("event entity @e [family=blastoise_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:blastoise_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_blastoise_s(player) {
    player.runCommandAsync("event entity @e [family=blastoise_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//blastoise shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("blastoise_s_fainted")){
            blastoise_s_fainted(player)
			player.removeTag("blastoise_s_fainted")
		}
  }
  function blastoise_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_blastoise_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_blastoise_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:blastoise_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:blastoise_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//caterpie
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("caterpie_interact")){
            caterpie_interact(player)
			player.removeTag("caterpie_interact")
		}
  }
  function caterpie_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_caterpie(player)
        }
        if (result.selection === 1) {
            return_caterpie(player)
        }
        if (result.selection === 2) {
            follow_caterpie(player)
        }
        if (result.selection === 3) {
            evolve_caterpie(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_caterpie(player) {
    player.runCommandAsync("event entity @e [family=caterpie,c=1,r=5] true:to_fight");
}
function return_caterpie(player) {
    player.runCommandAsync("event entity @e [family=caterpie,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:caterpie_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_caterpie(player) {
    player.runCommandAsync("event entity @e [family=caterpie,c=1,r=5] true:to_follow");
}
function evolve_caterpie (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=caterpie,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//caterpie fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("caterpie_fainted")){
            caterpie_fainted(player)
			player.removeTag("caterpie_fainted")
		}
  }
  function caterpie_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_caterpie_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_caterpie_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:caterpie_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:caterpie_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//caterpie shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("caterpie_s_interact")){
            caterpie_s_interact(player)
			player.removeTag("caterpie_s_interact")
		}
  }
  function caterpie_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_caterpie_s(player)
        }
        if (result.selection === 1) {
            return_caterpie_s(player)
        }
        if (result.selection === 2) {
            follow_caterpie_s(player)
        }
        if (result.selection === 3) {
            evolve_caterpie_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_caterpie_s(player) {
    player.runCommandAsync("event entity @e [family=caterpie_s,c=1,r=5] true:to_fight");
}
function return_caterpie_s(player) {
    player.runCommandAsync("event entity @e [family=caterpie_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:caterpie_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_caterpie_s(player) {
    player.runCommandAsync("event entity @e [family=caterpie_s,c=1,r=5] true:to_follow");
}
function evolve_caterpie_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=caterpie_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//caterpie shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("caterpie_s_fainted")){
            caterpie_s_fainted(player)
			player.removeTag("caterpie_s_fainted")
		}
  }
  function caterpie_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_caterpie_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_caterpie_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:caterpie_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:caterpie_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//metapod
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("metapod_interact")){
            metapod_interact(player)
			player.removeTag("metapod_interact")
		}
  }
  function metapod_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_metapod(player)
        }
        if (result.selection === 1) {
            return_metapod(player)
        }
        if (result.selection === 2) {
            follow_metapod(player)
        }
        if (result.selection === 3) {
            evolve_metapod(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_metapod(player) {
    player.runCommandAsync("event entity @e [family=metapod,c=1,r=5] true:to_fight");
}
function return_metapod(player) {
    player.runCommandAsync("event entity @e [family=metapod,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:metapod_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_metapod(player) {
    player.runCommandAsync("event entity @e [family=metapod,c=1,r=5] true:to_follow");
}
function evolve_metapod (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=metapod,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//metapod fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("metapod_fainted")){
            metapod_fainted(player)
			player.removeTag("metapod_fainted")
		}
  }
  function metapod_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_metapod_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_metapod_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:metapod_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:metapod_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//metapod shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("metapod_s_interact")){
            metapod_s_interact(player)
			player.removeTag("metapod_s_interact")
		}
  }
  function metapod_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_metapod_s(player)
        }
        if (result.selection === 1) {
            return_metapod_s(player)
        }
        if (result.selection === 2) {
            follow_metapod_s(player)
        }
        if (result.selection === 3) {
            evolve_metapod_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_metapod_s(player) {
    player.runCommandAsync("event entity @e [family=metapod_s,c=1,r=5] true:to_fight");
}
function return_metapod_s(player) {
    player.runCommandAsync("event entity @e [family=metapod_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:metapod_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_metapod_s(player) {
    player.runCommandAsync("event entity @e [family=metapod_s,c=1,r=5] true:to_follow");
}
function evolve_metapod_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=metapod_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//metapod shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("metapod_s_fainted")){
            metapod_s_fainted(player)
			player.removeTag("metapod_s_fainted")
		}
  }
  function metapod_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_metapod_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_metapod_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:metapod_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:metapod_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//butterfree
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("butterfree_interact")){
            butterfree_interact(player)
			player.removeTag("butterfree_interact")
		}
  }
  function butterfree_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_butterfree(player)
        }
        if (result.selection === 1) {
            return_butterfree(player)
        }
        if (result.selection === 2) {
            follow_butterfree(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_butterfree(player) {
    player.runCommandAsync("event entity @e [family=butterfree,c=1,r=5] true:to_fight");
}
function return_butterfree(player) {
    player.runCommandAsync("event entity @e [family=butterfree,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:butterfree_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_butterfree(player) {
    player.runCommandAsync("event entity @e [family=butterfree,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//butterfree fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("butterfree_fainted")){
            butterfree_fainted(player)
			player.removeTag("butterfree_fainted")
		}
  }
  function butterfree_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_butterfree_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_butterfree_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:butterfree_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:butterfree_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//butterfree shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("butterfree_s_interact")){
            butterfree_s_interact(player)
			player.removeTag("butterfree_s_interact")
		}
  }
  function butterfree_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_butterfree_s(player)
        }
        if (result.selection === 1) {
            return_butterfree_s(player)
        }
        if (result.selection === 2) {
            follow_butterfree_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_butterfree_s(player) {
    player.runCommandAsync("event entity @e [family=butterfree_s,c=1,r=5] true:to_fight");
}
function return_butterfree_s(player) {
    player.runCommandAsync("event entity @e [family=butterfree_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:butterfree_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_butterfree_s(player) {
    player.runCommandAsync("event entity @e [family=butterfree_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//butterfree shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("butterfree_s_fainted")){
            butterfree_s_fainted(player)
			player.removeTag("butterfree_s_fainted")
		}
  }
  function butterfree_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_butterfree_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_butterfree_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:butterfree_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:butterfree_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//weedle
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("weedle_interact")){
            weedle_interact(player)
			player.removeTag("weedle_interact")
		}
  }
  function weedle_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_weedle(player)
        }
        if (result.selection === 1) {
            return_weedle(player)
        }
        if (result.selection === 2) {
            follow_weedle(player)
        }
        if (result.selection === 3) {
            evolve_weedle(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_weedle(player) {
    player.runCommandAsync("event entity @e [family=weedle,c=1,r=5] true:to_fight");
}
function return_weedle(player) {
    player.runCommandAsync("event entity @e [family=weedle,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:weedle_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_weedle(player) {
    player.runCommandAsync("event entity @e [family=weedle,c=1,r=5] true:to_follow");
}
function evolve_weedle (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=weedle,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//weedle fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("weedle_fainted")){
            weedle_fainted(player)
			player.removeTag("weedle_fainted")
		}
  }
  function weedle_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_weedle_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_weedle_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:weedle_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:weedle_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//weedle shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("weedle_s_interact")){
            weedle_s_interact(player)
			player.removeTag("weedle_s_interact")
		}
  }
  function weedle_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_weedle_s(player)
        }
        if (result.selection === 1) {
            return_weedle_s(player)
        }
        if (result.selection === 2) {
            follow_weedle_s(player)
        }
        if (result.selection === 3) {
            evolve_weedle_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_weedle_s(player) {
    player.runCommandAsync("event entity @e [family=weedle_s,c=1,r=5] true:to_fight");
}
function return_weedle_s(player) {
    player.runCommandAsync("event entity @e [family=weedle_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:weedle_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_weedle_s(player) {
    player.runCommandAsync("event entity @e [family=weedle_s,c=1,r=5] true:to_follow");
}
function evolve_weedle_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=weedle_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//weedle shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("weedle_s_fainted")){
            weedle_s_fainted(player)
			player.removeTag("weedle_s_fainted")
		}
  }
  function weedle_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_weedle_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_weedle_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:weedle_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:weedle_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//kakuna
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("kakuna_interact")){
            kakuna_interact(player)
			player.removeTag("kakuna_interact")
		}
  }
  function kakuna_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_kakuna(player)
        }
        if (result.selection === 1) {
            return_kakuna(player)
        }
        if (result.selection === 2) {
            follow_kakuna(player)
        }
        if (result.selection === 3) {
            evolve_kakuna(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_kakuna(player) {
    player.runCommandAsync("event entity @e [family=kakuna,c=1,r=5] true:to_fight");
}
function return_kakuna(player) {
    player.runCommandAsync("event entity @e [family=kakuna,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:kakuna_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_kakuna(player) {
    player.runCommandAsync("event entity @e [family=kakuna,c=1,r=5] true:to_follow");
}
function evolve_kakuna (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=kakuna,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//kakuna fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("kakuna_fainted")){
            kakuna_fainted(player)
			player.removeTag("kakuna_fainted")
		}
  }
  function kakuna_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_kakuna_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_kakuna_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:kakuna_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:kakuna_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//kakuna shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("kakuna_s_interact")){
            kakuna_s_interact(player)
			player.removeTag("kakuna_s_interact")
		}
  }
  function kakuna_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_kakuna_s(player)
        }
        if (result.selection === 1) {
            return_kakuna_s(player)
        }
        if (result.selection === 2) {
            follow_kakuna_s(player)
        }
        if (result.selection === 3) {
            evolve_kakuna_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_kakuna_s(player) {
    player.runCommandAsync("event entity @e [family=kakuna_s,c=1,r=5] true:to_fight");
}
function return_kakuna_s(player) {
    player.runCommandAsync("event entity @e [family=kakuna_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:kakuna_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_kakuna_s(player) {
    player.runCommandAsync("event entity @e [family=kakuna_s,c=1,r=5] true:to_follow");
}
function evolve_kakuna_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=kakuna_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//kakuna shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("kakuna_s_fainted")){
            kakuna_s_fainted(player)
			player.removeTag("kakuna_s_fainted")
		}
  }
  function kakuna_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_kakuna_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_kakuna_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:kakuna_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:kakuna_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//beedrill
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("beedrill_interact")){
            beedrill_interact(player)
			player.removeTag("beedrill_interact")
		}
  }
  function beedrill_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_beedrill(player)
        }
        if (result.selection === 1) {
            return_beedrill(player)
        }
        if (result.selection === 2) {
            follow_beedrill(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_beedrill(player) {
    player.runCommandAsync("event entity @e [family=beedrill,c=1,r=5] true:to_fight");
}
function return_beedrill(player) {
    player.runCommandAsync("event entity @e [family=beedrill,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:beedrill_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_beedrill(player) {
    player.runCommandAsync("event entity @e [family=beedrill,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//beedrill fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("beedrill_fainted")){
            beedrill_fainted(player)
			player.removeTag("beedrill_fainted")
		}
  }
  function beedrill_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_beedrill_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_beedrill_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:beedrill_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:beedrill_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//beedrill shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("beedrill_s_interact")){
            beedrill_s_interact(player)
			player.removeTag("beedrill_s_interact")
		}
  }
  function beedrill_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_beedrill_s(player)
        }
        if (result.selection === 1) {
            return_beedrill_s(player)
        }
        if (result.selection === 2) {
            follow_beedrill_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_beedrill_s(player) {
    player.runCommandAsync("event entity @e [family=beedrill_s,c=1,r=5] true:to_fight");
}
function return_beedrill_s(player) {
    player.runCommandAsync("event entity @e [family=beedrill_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:beedrill_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_beedrill_s(player) {
    player.runCommandAsync("event entity @e [family=beedrill_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//beedrill shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("beedrill_s_fainted")){
            beedrill_s_fainted(player)
			player.removeTag("beedrill_s_fainted")
		}
  }
  function beedrill_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_beedrill_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_beedrill_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:beedrill_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:beedrill_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pidgey
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pidgey_interact")){
            pidgey_interact(player)
			player.removeTag("pidgey_interact")
		}
  }
  function pidgey_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_pidgey(player)
        }
        if (result.selection === 1) {
            return_pidgey(player)
        }
        if (result.selection === 2) {
            follow_pidgey(player)
        }
        if (result.selection === 3) {
            evolve_pidgey(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_pidgey(player) {
    player.runCommandAsync("event entity @e [family=pidgey,c=1,r=5] true:to_fight");
}
function return_pidgey(player) {
    player.runCommandAsync("event entity @e [family=pidgey,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pidgey_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_pidgey(player) {
    player.runCommandAsync("event entity @e [family=pidgey,c=1,r=5] true:to_follow");
}
function evolve_pidgey (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=pidgey,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pidgey fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pidgey_fainted")){
            pidgey_fainted(player)
			player.removeTag("pidgey_fainted")
		}
  }
  function pidgey_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_pidgey_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_pidgey_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:pidgey_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pidgey_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pidgey shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pidgey_s_interact")){
            pidgey_s_interact(player)
			player.removeTag("pidgey_s_interact")
		}
  }
  function pidgey_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_pidgey_s(player)
        }
        if (result.selection === 1) {
            return_pidgey_s(player)
        }
        if (result.selection === 2) {
            follow_pidgey_s(player)
        }
        if (result.selection === 3) {
            evolve_pidgey_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_pidgey_s(player) {
    player.runCommandAsync("event entity @e [family=pidgey_s,c=1,r=5] true:to_fight");
}
function return_pidgey_s(player) {
    player.runCommandAsync("event entity @e [family=pidgey_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pidgey_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_pidgey_s(player) {
    player.runCommandAsync("event entity @e [family=pidgey_s,c=1,r=5] true:to_follow");
}
function evolve_pidgey_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=pidgey_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pidgey shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pidgey_s_fainted")){
            pidgey_s_fainted(player)
			player.removeTag("pidgey_s_fainted")
		}
  }
  function pidgey_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_pidgey_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_pidgey_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:pidgey_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pidgey_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pidgeotto
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pidgeotto_interact")){
            pidgeotto_interact(player)
			player.removeTag("pidgeotto_interact")
		}
  }
  function pidgeotto_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_pidgeotto(player)
        }
        if (result.selection === 1) {
            return_pidgeotto(player)
        }
        if (result.selection === 2) {
            follow_pidgeotto(player)
        }
        if (result.selection === 3) {
            evolve_pidgeotto(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_pidgeotto(player) {
    player.runCommandAsync("event entity @e [family=pidgeotto,c=1,r=5] true:to_fight");
}
function return_pidgeotto(player) {
    player.runCommandAsync("event entity @e [family=pidgeotto,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pidgeotto_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_pidgeotto(player) {
    player.runCommandAsync("event entity @e [family=pidgeotto,c=1,r=5] true:to_follow");
}
function evolve_pidgeotto (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=pidgeotto,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pidgeotto fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pidgeotto_fainted")){
            pidgeotto_fainted(player)
			player.removeTag("pidgeotto_fainted")
		}
  }
  function pidgeotto_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_pidgeotto_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_pidgeotto_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:pidgeotto_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pidgeotto_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pidgeotto shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pidgeotto_s_interact")){
            pidgeotto_s_interact(player)
			player.removeTag("pidgeotto_s_interact")
		}
  }
  function pidgeotto_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_pidgeotto_s(player)
        }
        if (result.selection === 1) {
            return_pidgeotto_s(player)
        }
        if (result.selection === 2) {
            follow_pidgeotto_s(player)
        }
        if (result.selection === 3) {
            evolve_pidgeotto_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_pidgeotto_s(player) {
    player.runCommandAsync("event entity @e [family=pidgeotto_s,c=1,r=5] true:to_fight");
}
function return_pidgeotto_s(player) {
    player.runCommandAsync("event entity @e [family=pidgeotto_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pidgeotto_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_pidgeotto_s(player) {
    player.runCommandAsync("event entity @e [family=pidgeotto_s,c=1,r=5] true:to_follow");
}
function evolve_pidgeotto_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=pidgeotto_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pidgeotto shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pidgeotto_s_fainted")){
            pidgeotto_s_fainted(player)
			player.removeTag("pidgeotto_s_fainted")
		}
  }
  function pidgeotto_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_pidgeotto_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_pidgeotto_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:pidgeotto_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pidgeotto_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pidgeot
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pidgeot_interact")){
            pidgeot_interact(player)
			player.removeTag("pidgeot_interact")
		}
  }
  function pidgeot_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_pidgeot(player)
        }
        if (result.selection === 1) {
            return_pidgeot(player)
        }
        if (result.selection === 2) {
            follow_pidgeot(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_pidgeot(player) {
    player.runCommandAsync("event entity @e [family=pidgeot,c=1,r=5] true:to_fight");
}
function return_pidgeot(player) {
    player.runCommandAsync("event entity @e [family=pidgeot,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pidgeot_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_pidgeot(player) {
    player.runCommandAsync("event entity @e [family=pidgeot,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pidgeot fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pidgeot_fainted")){
            pidgeot_fainted(player)
			player.removeTag("pidgeot_fainted")
		}
  }
  function pidgeot_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_pidgeot_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_pidgeot_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:pidgeot_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pidgeot_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pidgeot shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pidgeot_s_interact")){
            pidgeot_s_interact(player)
			player.removeTag("pidgeot_s_interact")
		}
  }
  function pidgeot_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_pidgeot_s(player)
        }
        if (result.selection === 1) {
            return_pidgeot_s(player)
        }
        if (result.selection === 2) {
            follow_pidgeot_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_pidgeot_s(player) {
    player.runCommandAsync("event entity @e [family=pidgeot_s,c=1,r=5] true:to_fight");
}
function return_pidgeot_s(player) {
    player.runCommandAsync("event entity @e [family=pidgeot_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pidgeot_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_pidgeot_s(player) {
    player.runCommandAsync("event entity @e [family=pidgeot_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pidgeot shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pidgeot_s_fainted")){
            pidgeot_s_fainted(player)
			player.removeTag("pidgeot_s_fainted")
		}
  }
  function pidgeot_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_pidgeot_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_pidgeot_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:pidgeot_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pidgeot_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//rattata
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("rattata_interact")){
            rattata_interact(player)
			player.removeTag("rattata_interact")
		}
  }
  function rattata_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_rattata(player)
        }
        if (result.selection === 1) {
            return_rattata(player)
        }
        if (result.selection === 2) {
            follow_rattata(player)
        }
        if (result.selection === 3) {
            evolve_rattata(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_rattata(player) {
    player.runCommandAsync("event entity @e [family=rattata,c=1,r=5] true:to_fight");
}
function return_rattata(player) {
    player.runCommandAsync("event entity @e [family=rattata,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:rattata_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_rattata(player) {
    player.runCommandAsync("event entity @e [family=rattata,c=1,r=5] true:to_follow");
}
function evolve_rattata (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=rattata,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//rattata fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("rattata_fainted")){
            rattata_fainted(player)
			player.removeTag("rattata_fainted")
		}
  }
  function rattata_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_rattata_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_rattata_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:rattata_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:rattata_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//rattata shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("rattata_s_interact")){
            rattata_s_interact(player)
			player.removeTag("rattata_s_interact")
		}
  }
  function rattata_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_rattata_s(player)
        }
        if (result.selection === 1) {
            return_rattata_s(player)
        }
        if (result.selection === 2) {
            follow_rattata_s(player)
        }
        if (result.selection === 3) {
            evolve_rattata_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_rattata_s(player) {
    player.runCommandAsync("event entity @e [family=rattata_s,c=1,r=5] true:to_fight");
}
function return_rattata_s(player) {
    player.runCommandAsync("event entity @e [family=rattata_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:rattata_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_rattata_s(player) {
    player.runCommandAsync("event entity @e [family=rattata_s,c=1,r=5] true:to_follow");
}
function evolve_rattata_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=rattata_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//rattata shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("rattata_s_fainted")){
            rattata_s_fainted(player)
			player.removeTag("rattata_s_fainted")
		}
  }
  function rattata_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_rattata_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_rattata_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:rattata_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:rattata_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//raticate
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("raticate_interact")){
            raticate_interact(player)
			player.removeTag("raticate_interact")
		}
  }
  function raticate_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_raticate(player)
        }
        if (result.selection === 1) {
            return_raticate(player)
        }
        if (result.selection === 2) {
            follow_raticate(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_raticate(player) {
    player.runCommandAsync("event entity @e [family=raticate,c=1,r=5] true:to_fight");
}
function return_raticate(player) {
    player.runCommandAsync("event entity @e [family=raticate,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:raticate_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_raticate(player) {
    player.runCommandAsync("event entity @e [family=raticate,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//raticate fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("raticate_fainted")){
            raticate_fainted(player)
			player.removeTag("raticate_fainted")
		}
  }
  function raticate_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_raticate_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_raticate_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:raticate_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:raticate_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//raticate shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("raticate_s_interact")){
            raticate_s_interact(player)
			player.removeTag("raticate_s_interact")
		}
  }
  function raticate_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_raticate_s(player)
        }
        if (result.selection === 1) {
            return_raticate_s(player)
        }
        if (result.selection === 2) {
            follow_raticate_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_raticate_s(player) {
    player.runCommandAsync("event entity @e [family=raticate_s,c=1,r=5] true:to_fight");
}
function return_raticate_s(player) {
    player.runCommandAsync("event entity @e [family=raticate_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:raticate_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_raticate_s(player) {
    player.runCommandAsync("event entity @e [family=raticate_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//raticate shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("raticate_s_fainted")){
            raticate_s_fainted(player)
			player.removeTag("raticate_s_fainted")
		}
  }
  function raticate_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_raticate_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_raticate_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:raticate_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:raticate_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//spearow
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("spearow_interact")){
            spearow_interact(player)
			player.removeTag("spearow_interact")
		}
  }
  function spearow_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_spearow(player)
        }
        if (result.selection === 1) {
            return_spearow(player)
        }
        if (result.selection === 2) {
            follow_spearow(player)
        }
        if (result.selection === 3) {
            evolve_spearow(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_spearow(player) {
    player.runCommandAsync("event entity @e [family=spearow,c=1,r=5] true:to_fight");
}
function return_spearow(player) {
    player.runCommandAsync("event entity @e [family=spearow,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:spearow_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_spearow(player) {
    player.runCommandAsync("event entity @e [family=spearow,c=1,r=5] true:to_follow");
}
function evolve_spearow (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=spearow,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//spearow fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("spearow_fainted")){
            spearow_fainted(player)
			player.removeTag("spearow_fainted")
		}
  }
  function spearow_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_spearow_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_spearow_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:spearow_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:spearow_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//spearow shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("spearow_s_interact")){
            spearow_s_interact(player)
			player.removeTag("spearow_s_interact")
		}
  }
  function spearow_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_spearow_s(player)
        }
        if (result.selection === 1) {
            return_spearow_s(player)
        }
        if (result.selection === 2) {
            follow_spearow_s(player)
        }
        if (result.selection === 3) {
            evolve_spearow_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_spearow_s(player) {
    player.runCommandAsync("event entity @e [family=spearow_s,c=1,r=5] true:to_fight");
}
function return_spearow_s(player) {
    player.runCommandAsync("event entity @e [family=spearow_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:spearow_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_spearow_s(player) {
    player.runCommandAsync("event entity @e [family=spearow_s,c=1,r=5] true:to_follow");
}
function evolve_spearow_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=spearow_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//spearow shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("spearow_s_fainted")){
            spearow_s_fainted(player)
			player.removeTag("spearow_s_fainted")
		}
  }
  function spearow_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_spearow_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_spearow_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:spearow_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:spearow_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//fearow
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("fearow_interact")){
            fearow_interact(player)
			player.removeTag("fearow_interact")
		}
  }
  function fearow_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_fearow(player)
        }
        if (result.selection === 1) {
            return_fearow(player)
        }
        if (result.selection === 2) {
            follow_fearow(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_fearow(player) {
    player.runCommandAsync("event entity @e [family=fearow,c=1,r=5] true:to_fight");
}
function return_fearow(player) {
    player.runCommandAsync("event entity @e [family=fearow,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:fearow_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_fearow(player) {
    player.runCommandAsync("event entity @e [family=fearow,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//fearow fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("fearow_fainted")){
            fearow_fainted(player)
			player.removeTag("fearow_fainted")
		}
  }
  function fearow_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_fearow_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_fearow_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:fearow_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:fearow_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//fearow shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("fearow_s_interact")){
            fearow_s_interact(player)
			player.removeTag("fearow_s_interact")
		}
  }
  function fearow_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_fearow_s(player)
        }
        if (result.selection === 1) {
            return_fearow_s(player)
        }
        if (result.selection === 2) {
            follow_fearow_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_fearow_s(player) {
    player.runCommandAsync("event entity @e [family=fearow_s,c=1,r=5] true:to_fight");
}
function return_fearow_s(player) {
    player.runCommandAsync("event entity @e [family=fearow_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:fearow_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_fearow_s(player) {
    player.runCommandAsync("event entity @e [family=fearow_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//fearow shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("fearow_s_fainted")){
            fearow_s_fainted(player)
			player.removeTag("fearow_s_fainted")
		}
  }
  function fearow_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_fearow_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_fearow_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:fearow_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:fearow_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ekans
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ekans_interact")){
            ekans_interact(player)
			player.removeTag("ekans_interact")
		}
  }
  function ekans_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_ekans(player)
        }
        if (result.selection === 1) {
            return_ekans(player)
        }
        if (result.selection === 2) {
            follow_ekans(player)
        }
        if (result.selection === 3) {
            evolve_ekans(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_ekans(player) {
    player.runCommandAsync("event entity @e [family=ekans,c=1,r=5] true:to_fight");
}
function return_ekans(player) {
    player.runCommandAsync("event entity @e [family=ekans,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ekans_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_ekans(player) {
    player.runCommandAsync("event entity @e [family=ekans,c=1,r=5] true:to_follow");
}
function evolve_ekans (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=ekans,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ekans fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ekans_fainted")){
            ekans_fainted(player)
			player.removeTag("ekans_fainted")
		}
  }
  function ekans_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_ekans_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_ekans_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:ekans_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ekans_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ekans shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ekans_s_interact")){
            ekans_s_interact(player)
			player.removeTag("ekans_s_interact")
		}
  }
  function ekans_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_ekans_s(player)
        }
        if (result.selection === 1) {
            return_ekans_s(player)
        }
        if (result.selection === 2) {
            follow_ekans_s(player)
        }
        if (result.selection === 3) {
            evolve_ekans_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_ekans_s(player) {
    player.runCommandAsync("event entity @e [family=ekans_s,c=1,r=5] true:to_fight");
}
function return_ekans_s(player) {
    player.runCommandAsync("event entity @e [family=ekans_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ekans_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_ekans_s(player) {
    player.runCommandAsync("event entity @e [family=ekans_s,c=1,r=5] true:to_follow");
}
function evolve_ekans_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=ekans_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ekans shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ekans_s_fainted")){
            ekans_s_fainted(player)
			player.removeTag("ekans_s_fainted")
		}
  }
  function ekans_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_ekans_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_ekans_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:ekans_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ekans_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//arbok
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("arbok_interact")){
            arbok_interact(player)
			player.removeTag("arbok_interact")
		}
  }
  function arbok_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_arbok(player)
        }
        if (result.selection === 1) {
            return_arbok(player)
        }
        if (result.selection === 2) {
            follow_arbok(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_arbok(player) {
    player.runCommandAsync("event entity @e [family=arbok,c=1,r=5] true:to_fight");
}
function return_arbok(player) {
    player.runCommandAsync("event entity @e [family=arbok,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:arbok_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_arbok(player) {
    player.runCommandAsync("event entity @e [family=arbok,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//arbok fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("arbok_fainted")){
            arbok_fainted(player)
			player.removeTag("arbok_fainted")
		}
  }
  function arbok_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_arbok_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_arbok_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:arbok_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:arbok_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//arbok shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("arbok_s_interact")){
            arbok_s_interact(player)
			player.removeTag("arbok_s_interact")
		}
  }
  function arbok_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_arbok_s(player)
        }
        if (result.selection === 1) {
            return_arbok_s(player)
        }
        if (result.selection === 2) {
            follow_arbok_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_arbok_s(player) {
    player.runCommandAsync("event entity @e [family=arbok_s,c=1,r=5] true:to_fight");
}
function return_arbok_s(player) {
    player.runCommandAsync("event entity @e [family=arbok_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:arbok_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_arbok_s(player) {
    player.runCommandAsync("event entity @e [family=arbok_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//arbok shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("arbok_s_fainted")){
            arbok_s_fainted(player)
			player.removeTag("arbok_s_fainted")
		}
  }
  function arbok_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_arbok_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_arbok_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:arbok_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:arbok_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pikachu
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pikachu_interact")){
            pikachu_interact(player)
			player.removeTag("pikachu_interact")
		}
  }
  function pikachu_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_pikachu(player)
        }
        if (result.selection === 1) {
            return_pikachu(player)
        }
        if (result.selection === 2) {
            follow_pikachu(player)
        }
        if (result.selection === 3) {
            evolve_pikachu(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_pikachu(player) {
    player.runCommandAsync("event entity @e [family=pikachu,c=1,r=5] true:to_fight");
}
function return_pikachu(player) {
    player.runCommandAsync("event entity @e [family=pikachu,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pikachu_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_pikachu(player) {
    player.runCommandAsync("event entity @e [family=pikachu,c=1,r=5] true:to_follow");
}
function evolve_pikachu (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("thunder_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("thunder_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=pikachu,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:thunder_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pikachu fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pikachu_fainted")){
            pikachu_fainted(player)
			player.removeTag("pikachu_fainted")
		}
  }
  function pikachu_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_pikachu_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_pikachu_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:pikachu_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pikachu_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pikachu shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pikachu_s_interact")){
            pikachu_s_interact(player)
			player.removeTag("pikachu_s_interact")
		}
  }
  function pikachu_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_pikachu_s(player)
        }
        if (result.selection === 1) {
            return_pikachu_s(player)
        }
        if (result.selection === 2) {
            follow_pikachu_s(player)
        }
        if (result.selection === 3) {
            evolve_pikachu_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_pikachu_s(player) {
    player.runCommandAsync("event entity @e [family=pikachu_s,c=1,r=5] true:to_fight");
}
function return_pikachu_s(player) {
    player.runCommandAsync("event entity @e [family=pikachu_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pikachu_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_pikachu_s(player) {
    player.runCommandAsync("event entity @e [family=pikachu_s,c=1,r=5] true:to_follow");
}
function evolve_pikachu_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("thunder_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("thunder_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=pikachu_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:thunder_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//pikachu shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pikachu_s_fainted")){
            pikachu_s_fainted(player)
			player.removeTag("pikachu_s_fainted")
		}
  }
  function pikachu_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_pikachu_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_pikachu_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:pikachu_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:pikachu_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//raichu
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("raichu_interact")){
            raichu_interact(player)
			player.removeTag("raichu_interact")
		}
  }
  function raichu_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_raichu(player)
        }
        if (result.selection === 1) {
            return_raichu(player)
        }
        if (result.selection === 2) {
            follow_raichu(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_raichu(player) {
    player.runCommandAsync("event entity @e [family=raichu,c=1,r=5] true:to_fight");
}
function return_raichu(player) {
    player.runCommandAsync("event entity @e [family=raichu,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:raichu_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_raichu(player) {
    player.runCommandAsync("event entity @e [family=raichu,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//raichu fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("raichu_fainted")){
            raichu_fainted(player)
			player.removeTag("raichu_fainted")
		}
  }
  function raichu_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_raichu_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_raichu_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:raichu_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:raichu_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//raichu shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("raichu_s_interact")){
            raichu_s_interact(player)
			player.removeTag("raichu_s_interact")
		}
  }
  function raichu_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_raichu_s(player)
        }
        if (result.selection === 1) {
            return_raichu_s(player)
        }
        if (result.selection === 2) {
            follow_raichu_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_raichu_s(player) {
    player.runCommandAsync("event entity @e [family=raichu_s,c=1,r=5] true:to_fight");
}
function return_raichu_s(player) {
    player.runCommandAsync("event entity @e [family=raichu_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:raichu_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_raichu_s(player) {
    player.runCommandAsync("event entity @e [family=raichu_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//raichu shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("raichu_s_fainted")){
            raichu_s_fainted(player)
			player.removeTag("raichu_s_fainted")
		}
  }
  function raichu_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_raichu_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_raichu_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:raichu_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:raichu_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//sandshrew
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("sandshrew_interact")){
            sandshrew_interact(player)
			player.removeTag("sandshrew_interact")
		}
  }
  function sandshrew_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_sandshrew(player)
        }
        if (result.selection === 1) {
            return_sandshrew(player)
        }
        if (result.selection === 2) {
            follow_sandshrew(player)
        }
        if (result.selection === 3) {
            evolve_sandshrew(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_sandshrew(player) {
    player.runCommandAsync("event entity @e [family=sandshrew,c=1,r=5] true:to_fight");
}
function return_sandshrew(player) {
    player.runCommandAsync("event entity @e [family=sandshrew,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:sandshrew_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_sandshrew(player) {
    player.runCommandAsync("event entity @e [family=sandshrew,c=1,r=5] true:to_follow");
}
function evolve_sandshrew (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=sandshrew,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//sandshrew fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("sandshrew_fainted")){
            sandshrew_fainted(player)
			player.removeTag("sandshrew_fainted")
		}
  }
  function sandshrew_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_sandshrew_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_sandshrew_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:sandshrew_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:sandshrew_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//sandshrew shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("sandshrew_s_interact")){
            sandshrew_s_interact(player)
			player.removeTag("sandshrew_s_interact")
		}
  }
  function sandshrew_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_sandshrew_s(player)
        }
        if (result.selection === 1) {
            return_sandshrew_s(player)
        }
        if (result.selection === 2) {
            follow_sandshrew_s(player)
        }
        if (result.selection === 3) {
            evolve_sandshrew_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_sandshrew_s(player) {
    player.runCommandAsync("event entity @e [family=sandshrew_s,c=1,r=5] true:to_fight");
}
function return_sandshrew_s(player) {
    player.runCommandAsync("event entity @e [family=sandshrew_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:sandshrew_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_sandshrew_s(player) {
    player.runCommandAsync("event entity @e [family=sandshrew_s,c=1,r=5] true:to_follow");
}
function evolve_sandshrew_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=sandshrew_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//sandshrew shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("sandshrew_s_fainted")){
            sandshrew_s_fainted(player)
			player.removeTag("sandshrew_s_fainted")
		}
  }
  function sandshrew_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_sandshrew_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_sandshrew_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:sandshrew_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:sandshrew_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//sandslash
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("sandslash_interact")){
            sandslash_interact(player)
			player.removeTag("sandslash_interact")
		}
  }
  function sandslash_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_sandslash(player)
        }
        if (result.selection === 1) {
            return_sandslash(player)
        }
        if (result.selection === 2) {
            follow_sandslash(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_sandslash(player) {
    player.runCommandAsync("event entity @e [family=sandslash,c=1,r=5] true:to_fight");
}
function return_sandslash(player) {
    player.runCommandAsync("event entity @e [family=sandslash,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:sandslash_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_sandslash(player) {
    player.runCommandAsync("event entity @e [family=sandslash,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//sandslash fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("sandslash_fainted")){
            sandslash_fainted(player)
			player.removeTag("sandslash_fainted")
		}
  }
  function sandslash_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_sandslash_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_sandslash_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:sandslash_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:sandslash_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//sandslash shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("sandslash_s_interact")){
            sandslash_s_interact(player)
			player.removeTag("sandslash_s_interact")
		}
  }
  function sandslash_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_sandslash_s(player)
        }
        if (result.selection === 1) {
            return_sandslash_s(player)
        }
        if (result.selection === 2) {
            follow_sandslash_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_sandslash_s(player) {
    player.runCommandAsync("event entity @e [family=sandslash_s,c=1,r=5] true:to_fight");
}
function return_sandslash_s(player) {
    player.runCommandAsync("event entity @e [family=sandslash_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:sandslash_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_sandslash_s(player) {
    player.runCommandAsync("event entity @e [family=sandslash_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//sandslash shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("sandslash_s_fainted")){
            sandslash_s_fainted(player)
			player.removeTag("sandslash_s_fainted")
		}
  }
  function sandslash_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_sandslash_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_sandslash_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:sandslash_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:sandslash_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoranf
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoranf_interact")){
            nidoranf_interact(player)
			player.removeTag("nidoranf_interact")
		}
  }
  function nidoranf_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_nidoranf(player)
        }
        if (result.selection === 1) {
            return_nidoranf(player)
        }
        if (result.selection === 2) {
            follow_nidoranf(player)
        }
        if (result.selection === 3) {
            evolve_nidoranf(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_nidoranf(player) {
    player.runCommandAsync("event entity @e [family=nidoranf,c=1,r=5] true:to_fight");
}
function return_nidoranf(player) {
    player.runCommandAsync("event entity @e [family=nidoranf,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoranf_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_nidoranf(player) {
    player.runCommandAsync("event entity @e [family=nidoranf,c=1,r=5] true:to_follow");
}
function evolve_nidoranf (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=nidoranf,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoranf fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoranf_fainted")){
            nidoranf_fainted(player)
			player.removeTag("nidoranf_fainted")
		}
  }
  function nidoranf_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_nidoranf_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_nidoranf_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:nidoranf_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoranf_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoranf shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoranf_s_interact")){
            nidoranf_s_interact(player)
			player.removeTag("nidoranf_s_interact")
		}
  }
  function nidoranf_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_nidoranf_s(player)
        }
        if (result.selection === 1) {
            return_nidoranf_s(player)
        }
        if (result.selection === 2) {
            follow_nidoranf_s(player)
        }
        if (result.selection === 3) {
            evolve_nidoranf_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_nidoranf_s(player) {
    player.runCommandAsync("event entity @e [family=nidoranf_s,c=1,r=5] true:to_fight");
}
function return_nidoranf_s(player) {
    player.runCommandAsync("event entity @e [family=nidoranf_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoranf_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_nidoranf_s(player) {
    player.runCommandAsync("event entity @e [family=nidoranf_s,c=1,r=5] true:to_follow");
}
function evolve_nidoranf_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=nidoranf_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoranf shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoranf_s_fainted")){
            nidoranf_s_fainted(player)
			player.removeTag("nidoranf_s_fainted")
		}
  }
  function nidoranf_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_nidoranf_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_nidoranf_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:nidoranf_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoranf_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidorina
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidorina_interact")){
            nidorina_interact(player)
			player.removeTag("nidorina_interact")
		}
  }
  function nidorina_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_nidorina(player)
        }
        if (result.selection === 1) {
            return_nidorina(player)
        }
        if (result.selection === 2) {
            follow_nidorina(player)
        }
        if (result.selection === 3) {
            evolve_nidorina(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_nidorina(player) {
    player.runCommandAsync("event entity @e [family=nidorina,c=1,r=5] true:to_fight");
}
function return_nidorina(player) {
    player.runCommandAsync("event entity @e [family=nidorina,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidorina_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_nidorina(player) {
    player.runCommandAsync("event entity @e [family=nidorina,c=1,r=5] true:to_follow");
}
function evolve_nidorina (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("moon_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("moon_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=nidorina,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:moon_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidorina fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidorina_fainted")){
            nidorina_fainted(player)
			player.removeTag("nidorina_fainted")
		}
  }
  function nidorina_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_nidorina_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_nidorina_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:nidorina_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidorina_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidorina shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidorina_s_interact")){
            nidorina_s_interact(player)
			player.removeTag("nidorina_s_interact")
		}
  }
  function nidorina_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_nidorina_s(player)
        }
        if (result.selection === 1) {
            return_nidorina_s(player)
        }
        if (result.selection === 2) {
            follow_nidorina_s(player)
        }
        if (result.selection === 3) {
            evolve_nidorina_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_nidorina_s(player) {
    player.runCommandAsync("event entity @e [family=nidorina_s,c=1,r=5] true:to_fight");
}
function return_nidorina_s(player) {
    player.runCommandAsync("event entity @e [family=nidorina_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidorina_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_nidorina_s(player) {
    player.runCommandAsync("event entity @e [family=nidorina_s,c=1,r=5] true:to_follow");
}
function evolve_nidorina_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("moon_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("moon_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=nidorina_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:moon_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidorina shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidorina_s_fainted")){
            nidorina_s_fainted(player)
			player.removeTag("nidorina_s_fainted")
		}
  }
  function nidorina_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_nidorina_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_nidorina_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:nidorina_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidorina_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoqueen
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoqueen_interact")){
            nidoqueen_interact(player)
			player.removeTag("nidoqueen_interact")
		}
  }
  function nidoqueen_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_nidoqueen(player)
        }
        if (result.selection === 1) {
            return_nidoqueen(player)
        }
        if (result.selection === 2) {
            follow_nidoqueen(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_nidoqueen(player) {
    player.runCommandAsync("event entity @e [family=nidoqueen,c=1,r=5] true:to_fight");
}
function return_nidoqueen(player) {
    player.runCommandAsync("event entity @e [family=nidoqueen,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoqueen_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_nidoqueen(player) {
    player.runCommandAsync("event entity @e [family=nidoqueen,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoqueen fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoqueen_fainted")){
            nidoqueen_fainted(player)
			player.removeTag("nidoqueen_fainted")
		}
  }
  function nidoqueen_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_nidoqueen_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_nidoqueen_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:nidoqueen_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoqueen_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoqueen shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoqueen_s_interact")){
            nidoqueen_s_interact(player)
			player.removeTag("nidoqueen_s_interact")
		}
  }
  function nidoqueen_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_nidoqueen_s(player)
        }
        if (result.selection === 1) {
            return_nidoqueen_s(player)
        }
        if (result.selection === 2) {
            follow_nidoqueen_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_nidoqueen_s(player) {
    player.runCommandAsync("event entity @e [family=nidoqueen_s,c=1,r=5] true:to_fight");
}
function return_nidoqueen_s(player) {
    player.runCommandAsync("event entity @e [family=nidoqueen_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoqueen_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_nidoqueen_s(player) {
    player.runCommandAsync("event entity @e [family=nidoqueen_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoqueen shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoqueen_s_fainted")){
            nidoqueen_s_fainted(player)
			player.removeTag("nidoqueen_s_fainted")
		}
  }
  function nidoqueen_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_nidoqueen_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_nidoqueen_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:nidoqueen_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoqueen_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoranm
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoranm_interact")){
            nidoranm_interact(player)
			player.removeTag("nidoranm_interact")
		}
  }
  function nidoranm_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_nidoranm(player)
        }
        if (result.selection === 1) {
            return_nidoranm(player)
        }
        if (result.selection === 2) {
            follow_nidoranm(player)
        }
        if (result.selection === 3) {
            evolve_nidoranm(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_nidoranm(player) {
    player.runCommandAsync("event entity @e [family=nidoranm,c=1,r=5] true:to_fight");
}
function return_nidoranm(player) {
    player.runCommandAsync("event entity @e [family=nidoranm,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoranm_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_nidoranm(player) {
    player.runCommandAsync("event entity @e [family=nidoranm,c=1,r=5] true:to_follow");
}
function evolve_nidoranm (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=nidoranm,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoranm fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoranm_fainted")){
            nidoranm_fainted(player)
			player.removeTag("nidoranm_fainted")
		}
  }
  function nidoranm_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_nidoranm_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_nidoranm_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:nidoranm_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoranm_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoranm shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoranm_s_interact")){
            nidoranm_s_interact(player)
			player.removeTag("nidoranm_s_interact")
		}
  }
  function nidoranm_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_nidoranm_s(player)
        }
        if (result.selection === 1) {
            return_nidoranm_s(player)
        }
        if (result.selection === 2) {
            follow_nidoranm_s(player)
        }
        if (result.selection === 3) {
            evolve_nidoranm_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_nidoranm_s(player) {
    player.runCommandAsync("event entity @e [family=nidoranm_s,c=1,r=5] true:to_fight");
}
function return_nidoranm_s(player) {
    player.runCommandAsync("event entity @e [family=nidoranm_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoranm_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_nidoranm_s(player) {
    player.runCommandAsync("event entity @e [family=nidoranm_s,c=1,r=5] true:to_follow");
}
function evolve_nidoranm_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=nidoranm_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoranm shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoranm_s_fainted")){
            nidoranm_s_fainted(player)
			player.removeTag("nidoranm_s_fainted")
		}
  }
  function nidoranm_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_nidoranm_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_nidoranm_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:nidoranm_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoranm_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidorino
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidorino_interact")){
            nidorino_interact(player)
			player.removeTag("nidorino_interact")
		}
  }
  function nidorino_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_nidorino(player)
        }
        if (result.selection === 1) {
            return_nidorino(player)
        }
        if (result.selection === 2) {
            follow_nidorino(player)
        }
        if (result.selection === 3) {
            evolve_nidorino(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_nidorino(player) {
    player.runCommandAsync("event entity @e [family=nidorino,c=1,r=5] true:to_fight");
}
function return_nidorino(player) {
    player.runCommandAsync("event entity @e [family=nidorino,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidorino_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_nidorino(player) {
    player.runCommandAsync("event entity @e [family=nidorino,c=1,r=5] true:to_follow");
}
function evolve_nidorino (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("moon_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("moon_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=nidorino,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:moon_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidorino fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidorino_fainted")){
            nidorino_fainted(player)
			player.removeTag("nidorino_fainted")
		}
  }
  function nidorino_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_nidorino_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_nidorino_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:nidorino_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidorino_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidorino shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidorino_s_interact")){
            nidorino_s_interact(player)
			player.removeTag("nidorino_s_interact")
		}
  }
  function nidorino_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_nidorino_s(player)
        }
        if (result.selection === 1) {
            return_nidorino_s(player)
        }
        if (result.selection === 2) {
            follow_nidorino_s(player)
        }
        if (result.selection === 3) {
            evolve_nidorino_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_nidorino_s(player) {
    player.runCommandAsync("event entity @e [family=nidorino_s,c=1,r=5] true:to_fight");
}
function return_nidorino_s(player) {
    player.runCommandAsync("event entity @e [family=nidorino_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidorino_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_nidorino_s(player) {
    player.runCommandAsync("event entity @e [family=nidorino_s,c=1,r=5] true:to_follow");
}
function evolve_nidorino_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("moon_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("moon_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=nidorino_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:moon_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidorino shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidorino_s_fainted")){
            nidorino_s_fainted(player)
			player.removeTag("nidorino_s_fainted")
		}
  }
  function nidorino_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_nidorino_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_nidorino_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:nidorino_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidorino_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoking
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoking_interact")){
            nidoking_interact(player)
			player.removeTag("nidoking_interact")
		}
  }
  function nidoking_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_nidoking(player)
        }
        if (result.selection === 1) {
            return_nidoking(player)
        }
        if (result.selection === 2) {
            follow_nidoking(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_nidoking(player) {
    player.runCommandAsync("event entity @e [family=nidoking,c=1,r=5] true:to_fight");
}
function return_nidoking(player) {
    player.runCommandAsync("event entity @e [family=nidoking,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoking_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_nidoking(player) {
    player.runCommandAsync("event entity @e [family=nidoking,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoking fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoking_fainted")){
            nidoking_fainted(player)
			player.removeTag("nidoking_fainted")
		}
  }
  function nidoking_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_nidoking_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_nidoking_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:nidoking_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoking_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoking shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoking_s_interact")){
            nidoking_s_interact(player)
			player.removeTag("nidoking_s_interact")
		}
  }
  function nidoking_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_nidoking_s(player)
        }
        if (result.selection === 1) {
            return_nidoking_s(player)
        }
        if (result.selection === 2) {
            follow_nidoking_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_nidoking_s(player) {
    player.runCommandAsync("event entity @e [family=nidoking_s,c=1,r=5] true:to_fight");
}
function return_nidoking_s(player) {
    player.runCommandAsync("event entity @e [family=nidoking_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoking_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_nidoking_s(player) {
    player.runCommandAsync("event entity @e [family=nidoking_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//nidoking shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("nidoking_s_fainted")){
            nidoking_s_fainted(player)
			player.removeTag("nidoking_s_fainted")
		}
  }
  function nidoking_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_nidoking_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_nidoking_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:nidoking_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:nidoking_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//clefairy
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("clefairy_interact")){
            clefairy_interact(player)
			player.removeTag("clefairy_interact")
		}
  }
  function clefairy_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_clefairy(player)
        }
        if (result.selection === 1) {
            return_clefairy(player)
        }
        if (result.selection === 2) {
            follow_clefairy(player)
        }
        if (result.selection === 3) {
            evolve_clefairy(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_clefairy(player) {
    player.runCommandAsync("event entity @e [family=clefairy,c=1,r=5] true:to_fight");
}
function return_clefairy(player) {
    player.runCommandAsync("event entity @e [family=clefairy,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:clefairy_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_clefairy(player) {
    player.runCommandAsync("event entity @e [family=clefairy,c=1,r=5] true:to_follow");
}
function evolve_clefairy (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("moon_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("moon_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=clefairy,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:moon_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//clefairy fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("clefairy_fainted")){
            clefairy_fainted(player)
			player.removeTag("clefairy_fainted")
		}
  }
  function clefairy_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_clefairy_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_clefairy_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:clefairy_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:clefairy_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//clefairy shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("clefairy_s_interact")){
            clefairy_s_interact(player)
			player.removeTag("clefairy_s_interact")
		}
  }
  function clefairy_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_clefairy_s(player)
        }
        if (result.selection === 1) {
            return_clefairy_s(player)
        }
        if (result.selection === 2) {
            follow_clefairy_s(player)
        }
        if (result.selection === 3) {
            evolve_clefairy_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_clefairy_s(player) {
    player.runCommandAsync("event entity @e [family=clefairy_s,c=1,r=5] true:to_fight");
}
function return_clefairy_s(player) {
    player.runCommandAsync("event entity @e [family=clefairy_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:clefairy_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_clefairy_s(player) {
    player.runCommandAsync("event entity @e [family=clefairy_s,c=1,r=5] true:to_follow");
}
function evolve_clefairy_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("moon_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("moon_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=clefairy_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:moon_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//clefairy shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("clefairy_s_fainted")){
            clefairy_s_fainted(player)
			player.removeTag("clefairy_s_fainted")
		}
  }
  function clefairy_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_clefairy_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_clefairy_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:clefairy_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:clefairy_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//clefable
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("clefable_interact")){
            clefable_interact(player)
			player.removeTag("clefable_interact")
		}
  }
  function clefable_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_clefable(player)
        }
        if (result.selection === 1) {
            return_clefable(player)
        }
        if (result.selection === 2) {
            follow_clefable(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_clefable(player) {
    player.runCommandAsync("event entity @e [family=clefable,c=1,r=5] true:to_fight");
}
function return_clefable(player) {
    player.runCommandAsync("event entity @e [family=clefable,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:clefable_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_clefable(player) {
    player.runCommandAsync("event entity @e [family=clefable,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//clefable fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("clefable_fainted")){
            clefable_fainted(player)
			player.removeTag("clefable_fainted")
		}
  }
  function clefable_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_clefable_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_clefable_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:clefable_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:clefable_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//clefable shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("clefable_s_interact")){
            clefable_s_interact(player)
			player.removeTag("clefable_s_interact")
		}
  }
  function clefable_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_clefable_s(player)
        }
        if (result.selection === 1) {
            return_clefable_s(player)
        }
        if (result.selection === 2) {
            follow_clefable_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_clefable_s(player) {
    player.runCommandAsync("event entity @e [family=clefable_s,c=1,r=5] true:to_fight");
}
function return_clefable_s(player) {
    player.runCommandAsync("event entity @e [family=clefable_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:clefable_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_clefable_s(player) {
    player.runCommandAsync("event entity @e [family=clefable_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//clefable shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("clefable_s_fainted")){
            clefable_s_fainted(player)
			player.removeTag("clefable_s_fainted")
		}
  }
  function clefable_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_clefable_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_clefable_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:clefable_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:clefable_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//vulpix
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("vulpix_interact")){
            vulpix_interact(player)
			player.removeTag("vulpix_interact")
		}
  }
  function vulpix_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_vulpix(player)
        }
        if (result.selection === 1) {
            return_vulpix(player)
        }
        if (result.selection === 2) {
            follow_vulpix(player)
        }
        if (result.selection === 3) {
            evolve_vulpix(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_vulpix(player) {
    player.runCommandAsync("event entity @e [family=vulpix,c=1,r=5] true:to_fight");
}
function return_vulpix(player) {
    player.runCommandAsync("event entity @e [family=vulpix,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:vulpix_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_vulpix(player) {
    player.runCommandAsync("event entity @e [family=vulpix,c=1,r=5] true:to_follow");
}
function evolve_vulpix (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("fire_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("fire_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=vulpix,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:fire_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//vulpix fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("vulpix_fainted")){
            vulpix_fainted(player)
			player.removeTag("vulpix_fainted")
		}
  }
  function vulpix_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_vulpix_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_vulpix_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:vulpix_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:vulpix_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//vulpix shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("vulpix_s_interact")){
            vulpix_s_interact(player)
			player.removeTag("vulpix_s_interact")
		}
  }
  function vulpix_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_vulpix_s(player)
        }
        if (result.selection === 1) {
            return_vulpix_s(player)
        }
        if (result.selection === 2) {
            follow_vulpix_s(player)
        }
        if (result.selection === 3) {
            evolve_vulpix_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_vulpix_s(player) {
    player.runCommandAsync("event entity @e [family=vulpix_s,c=1,r=5] true:to_fight");
}
function return_vulpix_s(player) {
    player.runCommandAsync("event entity @e [family=vulpix_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:vulpix_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_vulpix_s(player) {
    player.runCommandAsync("event entity @e [family=vulpix_s,c=1,r=5] true:to_follow");
}
function evolve_vulpix_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("fire_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("fire_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=vulpix_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:fire_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//vulpix shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("vulpix_s_fainted")){
            vulpix_s_fainted(player)
			player.removeTag("vulpix_s_fainted")
		}
  }
  function vulpix_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_vulpix_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_vulpix_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:vulpix_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:vulpix_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ninetales
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ninetales_interact")){
            ninetales_interact(player)
			player.removeTag("ninetales_interact")
		}
  }
  function ninetales_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_ninetales(player)
        }
        if (result.selection === 1) {
            return_ninetales(player)
        }
        if (result.selection === 2) {
            follow_ninetales(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_ninetales(player) {
    player.runCommandAsync("event entity @e [family=ninetales,c=1,r=5] true:to_fight");
}
function return_ninetales(player) {
    player.runCommandAsync("event entity @e [family=ninetales,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ninetales_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_ninetales(player) {
    player.runCommandAsync("event entity @e [family=ninetales,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ninetales fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ninetales_fainted")){
            ninetales_fainted(player)
			player.removeTag("ninetales_fainted")
		}
  }
  function ninetales_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_ninetales_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_ninetales_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:ninetales_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ninetales_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ninetales shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ninetales_s_interact")){
            ninetales_s_interact(player)
			player.removeTag("ninetales_s_interact")
		}
  }
  function ninetales_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_ninetales_s(player)
        }
        if (result.selection === 1) {
            return_ninetales_s(player)
        }
        if (result.selection === 2) {
            follow_ninetales_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_ninetales_s(player) {
    player.runCommandAsync("event entity @e [family=ninetales_s,c=1,r=5] true:to_fight");
}
function return_ninetales_s(player) {
    player.runCommandAsync("event entity @e [family=ninetales_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ninetales_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_ninetales_s(player) {
    player.runCommandAsync("event entity @e [family=ninetales_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ninetales shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ninetales_s_fainted")){
            ninetales_s_fainted(player)
			player.removeTag("ninetales_s_fainted")
		}
  }
  function ninetales_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_ninetales_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_ninetales_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:ninetales_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ninetales_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//jigglypuff
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("jigglypuff_interact")){
            jigglypuff_interact(player)
			player.removeTag("jigglypuff_interact")
		}
  }
  function jigglypuff_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_jigglypuff(player)
        }
        if (result.selection === 1) {
            return_jigglypuff(player)
        }
        if (result.selection === 2) {
            follow_jigglypuff(player)
        }
        if (result.selection === 3) {
            evolve_jigglypuff(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_jigglypuff(player) {
    player.runCommandAsync("event entity @e [family=jigglypuff,c=1,r=5] true:to_fight");
}
function return_jigglypuff(player) {
    player.runCommandAsync("event entity @e [family=jigglypuff,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:jigglypuff_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_jigglypuff(player) {
    player.runCommandAsync("event entity @e [family=jigglypuff,c=1,r=5] true:to_follow");
}
function evolve_jigglypuff (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("moon_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("moon_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=jigglypuff,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:moon_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//jigglypuff fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("jigglypuff_fainted")){
            jigglypuff_fainted(player)
			player.removeTag("jigglypuff_fainted")
		}
  }
  function jigglypuff_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_jigglypuff_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_jigglypuff_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:jigglypuff_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:jigglypuff_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//jigglypuff shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("jigglypuff_s_interact")){
            jigglypuff_s_interact(player)
			player.removeTag("jigglypuff_s_interact")
		}
  }
  function jigglypuff_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_jigglypuff_s(player)
        }
        if (result.selection === 1) {
            return_jigglypuff_s(player)
        }
        if (result.selection === 2) {
            follow_jigglypuff_s(player)
        }
        if (result.selection === 3) {
            evolve_jigglypuff_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_jigglypuff_s(player) {
    player.runCommandAsync("event entity @e [family=jigglypuff_s,c=1,r=5] true:to_fight");
}
function return_jigglypuff_s(player) {
    player.runCommandAsync("event entity @e [family=jigglypuff_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:jigglypuff_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_jigglypuff_s(player) {
    player.runCommandAsync("event entity @e [family=jigglypuff_s,c=1,r=5] true:to_follow");
}
function evolve_jigglypuff_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("moon_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("moon_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=jigglypuff_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:moon_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//jigglypuff shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("jigglypuff_s_fainted")){
            jigglypuff_s_fainted(player)
			player.removeTag("jigglypuff_s_fainted")
		}
  }
  function jigglypuff_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_jigglypuff_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_jigglypuff_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:jigglypuff_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:jigglypuff_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//wigglytuff
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("wigglytuff_interact")){
            wigglytuff_interact(player)
			player.removeTag("wigglytuff_interact")
		}
  }
  function wigglytuff_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_wigglytuff(player)
        }
        if (result.selection === 1) {
            return_wigglytuff(player)
        }
        if (result.selection === 2) {
            follow_wigglytuff(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_wigglytuff(player) {
    player.runCommandAsync("event entity @e [family=wigglytuff,c=1,r=5] true:to_fight");
}
function return_wigglytuff(player) {
    player.runCommandAsync("event entity @e [family=wigglytuff,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:wigglytuff_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_wigglytuff(player) {
    player.runCommandAsync("event entity @e [family=wigglytuff,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//wigglytuff fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("wigglytuff_fainted")){
            wigglytuff_fainted(player)
			player.removeTag("wigglytuff_fainted")
		}
  }
  function wigglytuff_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_wigglytuff_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_wigglytuff_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:wigglytuff_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:wigglytuff_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//wigglytuff shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("wigglytuff_s_interact")){
            wigglytuff_s_interact(player)
			player.removeTag("wigglytuff_s_interact")
		}
  }
  function wigglytuff_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_wigglytuff_s(player)
        }
        if (result.selection === 1) {
            return_wigglytuff_s(player)
        }
        if (result.selection === 2) {
            follow_wigglytuff_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_wigglytuff_s(player) {
    player.runCommandAsync("event entity @e [family=wigglytuff_s,c=1,r=5] true:to_fight");
}
function return_wigglytuff_s(player) {
    player.runCommandAsync("event entity @e [family=wigglytuff_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:wigglytuff_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_wigglytuff_s(player) {
    player.runCommandAsync("event entity @e [family=wigglytuff_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//wigglytuff shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("wigglytuff_s_fainted")){
            wigglytuff_s_fainted(player)
			player.removeTag("wigglytuff_s_fainted")
		}
  }
  function wigglytuff_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_wigglytuff_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_wigglytuff_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:wigglytuff_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:wigglytuff_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//zubat
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("zubat_interact")){
            zubat_interact(player)
			player.removeTag("zubat_interact")
		}
  }
  function zubat_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_zubat(player)
        }
        if (result.selection === 1) {
            return_zubat(player)
        }
        if (result.selection === 2) {
            follow_zubat(player)
        }
        if (result.selection === 3) {
            evolve_zubat(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_zubat(player) {
    player.runCommandAsync("event entity @e [family=zubat,c=1,r=5] true:to_fight");
}
function return_zubat(player) {
    player.runCommandAsync("event entity @e [family=zubat,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:zubat_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_zubat(player) {
    player.runCommandAsync("event entity @e [family=zubat,c=1,r=5] true:to_follow");
}
function evolve_zubat (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=zubat,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//zubat fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("zubat_fainted")){
            zubat_fainted(player)
			player.removeTag("zubat_fainted")
		}
  }
  function zubat_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_zubat_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_zubat_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:zubat_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:zubat_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//zubat shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("zubat_s_interact")){
            zubat_s_interact(player)
			player.removeTag("zubat_s_interact")
		}
  }
  function zubat_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_zubat_s(player)
        }
        if (result.selection === 1) {
            return_zubat_s(player)
        }
        if (result.selection === 2) {
            follow_zubat_s(player)
        }
        if (result.selection === 3) {
            evolve_zubat_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_zubat_s(player) {
    player.runCommandAsync("event entity @e [family=zubat_s,c=1,r=5] true:to_fight");
}
function return_zubat_s(player) {
    player.runCommandAsync("event entity @e [family=zubat_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:zubat_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_zubat_s(player) {
    player.runCommandAsync("event entity @e [family=zubat_s,c=1,r=5] true:to_follow");
}
function evolve_zubat_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=zubat_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//zubat shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("zubat_s_fainted")){
            zubat_s_fainted(player)
			player.removeTag("zubat_s_fainted")
		}
  }
  function zubat_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_zubat_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_zubat_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:zubat_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:zubat_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//golbat
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("golbat_interact")){
            golbat_interact(player)
			player.removeTag("golbat_interact")
		}
  }
  function golbat_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_golbat(player)
        }
        if (result.selection === 1) {
            return_golbat(player)
        }
        if (result.selection === 2) {
            follow_golbat(player)
        }
        if (result.selection === 3) {
            evolve_golbat(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_golbat(player) {
    player.runCommandAsync("event entity @e [family=golbat,c=1,r=5] true:to_fight");
}
function return_golbat(player) {
    player.runCommandAsync("event entity @e [family=golbat,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:golbat_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_golbat(player) {
    player.runCommandAsync("event entity @e [family=golbat,c=1,r=5] true:to_follow");
}
function evolve_golbat (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("friendship")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("friendship")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=golbat,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:friendship 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//golbat fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("golbat_fainted")){
            golbat_fainted(player)
			player.removeTag("golbat_fainted")
		}
  }
  function golbat_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_golbat_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_golbat_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:golbat_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:golbat_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//golbat shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("golbat_s_interact")){
            golbat_s_interact(player)
			player.removeTag("golbat_s_interact")
		}
  }
  function golbat_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_golbat_s(player)
        }
        if (result.selection === 1) {
            return_golbat_s(player)
        }
        if (result.selection === 2) {
            follow_golbat_s(player)
        }
        if (result.selection === 3) {
            evolve_golbat_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_golbat_s(player) {
    player.runCommandAsync("event entity @e [family=golbat_s,c=1,r=5] true:to_fight");
}
function return_golbat_s(player) {
    player.runCommandAsync("event entity @e [family=golbat_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:golbat_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_golbat_s(player) {
    player.runCommandAsync("event entity @e [family=golbat_s,c=1,r=5] true:to_follow");
}
function evolve_golbat_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("friendship")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("friendship")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=golbat_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:friendship 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//golbat shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("golbat_s_fainted")){
            golbat_s_fainted(player)
			player.removeTag("golbat_s_fainted")
		}
  }
  function golbat_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_golbat_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_golbat_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:golbat_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:golbat_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//oddish
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("oddish_interact")){
            oddish_interact(player)
			player.removeTag("oddish_interact")
		}
  }
  function oddish_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_oddish(player)
        }
        if (result.selection === 1) {
            return_oddish(player)
        }
        if (result.selection === 2) {
            follow_oddish(player)
        }
        if (result.selection === 3) {
            evolve_oddish(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_oddish(player) {
    player.runCommandAsync("event entity @e [family=oddish,c=1,r=5] true:to_fight");
}
function return_oddish(player) {
    player.runCommandAsync("event entity @e [family=oddish,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:oddish_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_oddish(player) {
    player.runCommandAsync("event entity @e [family=oddish,c=1,r=5] true:to_follow");
}
function evolve_oddish (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=oddish,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//oddish fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("oddish_fainted")){
            oddish_fainted(player)
			player.removeTag("oddish_fainted")
		}
  }
  function oddish_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_oddish_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_oddish_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:oddish_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:oddish_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//oddish shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("oddish_s_interact")){
            oddish_s_interact(player)
			player.removeTag("oddish_s_interact")
		}
  }
  function oddish_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_oddish_s(player)
        }
        if (result.selection === 1) {
            return_oddish_s(player)
        }
        if (result.selection === 2) {
            follow_oddish_s(player)
        }
        if (result.selection === 3) {
            evolve_oddish_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_oddish_s(player) {
    player.runCommandAsync("event entity @e [family=oddish_s,c=1,r=5] true:to_fight");
}
function return_oddish_s(player) {
    player.runCommandAsync("event entity @e [family=oddish_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:oddish_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_oddish_s(player) {
    player.runCommandAsync("event entity @e [family=oddish_s,c=1,r=5] true:to_follow");
}
function evolve_oddish_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=oddish_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//oddish shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("oddish_s_fainted")){
            oddish_s_fainted(player)
			player.removeTag("oddish_s_fainted")
		}
  }
  function oddish_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_oddish_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_oddish_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:oddish_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:oddish_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//gloom
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("gloom_interact")){
            gloom_interact(player)
			player.removeTag("gloom_interact")
		}
  }
  function gloom_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_gloom(player)
        }
        if (result.selection === 1) {
            return_gloom(player)
        }
        if (result.selection === 2) {
            follow_gloom(player)
        }
        if (result.selection === 3) {
            evolve_gloom(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_gloom(player) {
    player.runCommandAsync("event entity @e [family=gloom,c=1,r=5] true:to_fight");
}
function return_gloom(player) {
    player.runCommandAsync("event entity @e [family=gloom,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:gloom_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_gloom(player) {
    player.runCommandAsync("event entity @e [family=gloom,c=1,r=5] true:to_follow");
}
function evolve_gloom (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('VILEPLUME!', 'textures/gui/menu/pokemon/vileplume_icon')
    gui.button('BELLOSSOM!', 'textures/gui/menu/pokemon/bellossom_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("leaf_stone")) {
            evolution_confirm_vileplume(player)
        }
        if (result.selection === 0 && !player.hasTag("leaf_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1 && player.hasTag("sunny_stone")) {
            evolution_confirm_bellossom(player)
        }
        if (result.selection === 1 && !player.hasTag("sunny_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 2) {
            exit(player)
        }
    }
)
}
function evolution_confirm_vileplume(player) {
    player.runCommandAsync("event entity @e [family=gloom,c=1,r=5] true:to_evolve_vileplume");
    player.runCommandAsync("clear @s true:leaf_stone 0 1");
}
function evolution_confirm_bellossom(player) {
    player.runCommandAsync("event entity @e [family=gloom,c=1,r=5] true:to_evolve_bellossom");
    player.runCommandAsync("clear @s true:sun_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//gloom fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("gloom_fainted")){
            gloom_fainted(player)
			player.removeTag("gloom_fainted")
		}
  }
  function gloom_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_gloom_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_gloom_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:gloom_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:gloom_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//gloom shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("gloom_s_interact")){
            gloom_s_interact(player)
			player.removeTag("gloom_s_interact")
		}
  }
  function gloom_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_gloom_s(player)
        }
        if (result.selection === 1) {
            return_gloom_s(player)
        }
        if (result.selection === 2) {
            follow_gloom_s(player)
        }
        if (result.selection === 3) {
            evolve_gloom_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_gloom_s(player) {
    player.runCommandAsync("event entity @e [family=gloom_s,c=1,r=5] true:to_fight");
}
function return_gloom_s(player) {
    player.runCommandAsync("event entity @e [family=gloom_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:gloom_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_gloom_s(player) {
    player.runCommandAsync("event entity @e [family=gloom_s,c=1,r=5] true:to_follow");
}
function evolve_gloom_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('VILEPLUME!', 'textures/gui/menu/pokemon/vileplume_s_icon')
    gui.button('BELLOSSOM!', 'textures/gui/menu/pokemon/bellossom_s_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("leaf_stone")) {
            evolution_confirm_vileplume(player)
        }
        if (result.selection === 0 && !player.hasTag("leaf_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1 && player.hasTag("sunny_stone")) {
            evolution_confirm_bellossom(player)
        }
        if (result.selection === 1 && !player.hasTag("sunny_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 2) {
            exit(player)
        }
    }
)
}
function evolution_confirm_vileplume(player) {
    player.runCommandAsync("event entity @e [family=gloom_s,c=1,r=5] true:to_evolve_vileplume");
    player.runCommandAsync("clear @s true:leaf_stone 0 1");
}
function evolution_confirm_bellossom(player) {
    player.runCommandAsync("event entity @e [family=gloom_s,c=1,r=5] true:to_evolve_bellossom");
    player.runCommandAsync("clear @s true:sun_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//gloom shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("gloom_s_fainted")){
            gloom_s_fainted(player)
			player.removeTag("gloom_s_fainted")
		}
  }
  function gloom_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_gloom_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_gloom_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:gloom_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:gloom_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//vileplume
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("vileplume_interact")){
            vileplume_interact(player)
			player.removeTag("vileplume_interact")
		}
  }
  function vileplume_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_vileplume(player)
        }
        if (result.selection === 1) {
            return_vileplume(player)
        }
        if (result.selection === 2) {
            follow_vileplume(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_vileplume(player) {
    player.runCommandAsync("event entity @e [family=vileplume,c=1,r=5] true:to_fight");
}
function return_vileplume(player) {
    player.runCommandAsync("event entity @e [family=vileplume,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:vileplume_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_vileplume(player) {
    player.runCommandAsync("event entity @e [family=vileplume,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//vileplume fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("vileplume_fainted")){
            vileplume_fainted(player)
			player.removeTag("vileplume_fainted")
		}
  }
  function vileplume_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_vileplume_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_vileplume_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:vileplume_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:vileplume_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//vileplume shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("vileplume_s_interact")){
            vileplume_s_interact(player)
			player.removeTag("vileplume_s_interact")
		}
  }
  function vileplume_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_vileplume_s(player)
        }
        if (result.selection === 1) {
            return_vileplume_s(player)
        }
        if (result.selection === 2) {
            follow_vileplume_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_vileplume_s(player) {
    player.runCommandAsync("event entity @e [family=vileplume_s,c=1,r=5] true:to_fight");
}
function return_vileplume_s(player) {
    player.runCommandAsync("event entity @e [family=vileplume_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:vileplume_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_vileplume_s(player) {
    player.runCommandAsync("event entity @e [family=vileplume_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//vileplume shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("vileplume_s_fainted")){
            vileplume_s_fainted(player)
			player.removeTag("vileplume_s_fainted")
		}
  }
  function vileplume_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_vileplume_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_vileplume_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:vileplume_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:vileplume_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//paras
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("paras_interact")){
            paras_interact(player)
			player.removeTag("paras_interact")
		}
  }
  function paras_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_paras(player)
        }
        if (result.selection === 1) {
            return_paras(player)
        }
        if (result.selection === 2) {
            follow_paras(player)
        }
        if (result.selection === 3) {
            evolve_paras(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_paras(player) {
    player.runCommandAsync("event entity @e [family=paras,c=1,r=5] true:to_fight");
}
function return_paras(player) {
    player.runCommandAsync("event entity @e [family=paras,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:paras_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_paras(player) {
    player.runCommandAsync("event entity @e [family=paras,c=1,r=5] true:to_follow");
}
function evolve_paras (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=paras,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//paras fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("paras_fainted")){
            paras_fainted(player)
			player.removeTag("paras_fainted")
		}
  }
  function paras_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_paras_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_paras_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:paras_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:paras_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//paras shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("paras_s_interact")){
            paras_s_interact(player)
			player.removeTag("paras_s_interact")
		}
  }
  function paras_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_paras_s(player)
        }
        if (result.selection === 1) {
            return_paras_s(player)
        }
        if (result.selection === 2) {
            follow_paras_s(player)
        }
        if (result.selection === 3) {
            evolve_paras_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_paras_s(player) {
    player.runCommandAsync("event entity @e [family=paras_s,c=1,r=5] true:to_fight");
}
function return_paras_s(player) {
    player.runCommandAsync("event entity @e [family=paras_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:paras_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_paras_s(player) {
    player.runCommandAsync("event entity @e [family=paras_s,c=1,r=5] true:to_follow");
}
function evolve_paras_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=paras_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//paras shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("paras_s_fainted")){
            paras_s_fainted(player)
			player.removeTag("paras_s_fainted")
		}
  }
  function paras_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_paras_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_paras_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:paras_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:paras_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//parasect
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("parasect_interact")){
            parasect_interact(player)
			player.removeTag("parasect_interact")
		}
  }
  function parasect_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_parasect(player)
        }
        if (result.selection === 1) {
            return_parasect(player)
        }
        if (result.selection === 2) {
            follow_parasect(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_parasect(player) {
    player.runCommandAsync("event entity @e [family=parasect,c=1,r=5] true:to_fight");
}
function return_parasect(player) {
    player.runCommandAsync("event entity @e [family=parasect,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:parasect_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_parasect(player) {
    player.runCommandAsync("event entity @e [family=parasect,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//parasect fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("parasect_fainted")){
            parasect_fainted(player)
			player.removeTag("parasect_fainted")
		}
  }
  function parasect_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_parasect_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_parasect_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:parasect_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:parasect_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//parasect shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("parasect_s_interact")){
            parasect_s_interact(player)
			player.removeTag("parasect_s_interact")
		}
  }
  function parasect_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_parasect_s(player)
        }
        if (result.selection === 1) {
            return_parasect_s(player)
        }
        if (result.selection === 2) {
            follow_parasect_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_parasect_s(player) {
    player.runCommandAsync("event entity @e [family=parasect_s,c=1,r=5] true:to_fight");
}
function return_parasect_s(player) {
    player.runCommandAsync("event entity @e [family=parasect_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:parasect_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_parasect_s(player) {
    player.runCommandAsync("event entity @e [family=parasect_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//parasect shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("parasect_s_fainted")){
            parasect_s_fainted(player)
			player.removeTag("parasect_s_fainted")
		}
  }
  function parasect_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_parasect_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_parasect_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:parasect_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:parasect_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//venonat
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("venonat_interact")){
            venonat_interact(player)
			player.removeTag("venonat_interact")
		}
  }
  function venonat_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_venonat(player)
        }
        if (result.selection === 1) {
            return_venonat(player)
        }
        if (result.selection === 2) {
            follow_venonat(player)
        }
        if (result.selection === 3) {
            evolve_venonat(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_venonat(player) {
    player.runCommandAsync("event entity @e [family=venonat,c=1,r=5] true:to_fight");
}
function return_venonat(player) {
    player.runCommandAsync("event entity @e [family=venonat,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:venonat_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_venonat(player) {
    player.runCommandAsync("event entity @e [family=venonat,c=1,r=5] true:to_follow");
}
function evolve_venonat (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=venonat,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//venonat fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("venonat_fainted")){
            venonat_fainted(player)
			player.removeTag("venonat_fainted")
		}
  }
  function venonat_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_venonat_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_venonat_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:venonat_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:venonat_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//venonat shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("venonat_s_interact")){
            venonat_s_interact(player)
			player.removeTag("venonat_s_interact")
		}
  }
  function venonat_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_venonat_s(player)
        }
        if (result.selection === 1) {
            return_venonat_s(player)
        }
        if (result.selection === 2) {
            follow_venonat_s(player)
        }
        if (result.selection === 3) {
            evolve_venonat_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_venonat_s(player) {
    player.runCommandAsync("event entity @e [family=venonat_s,c=1,r=5] true:to_fight");
}
function return_venonat_s(player) {
    player.runCommandAsync("event entity @e [family=venonat_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:venonat_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_venonat_s(player) {
    player.runCommandAsync("event entity @e [family=venonat_s,c=1,r=5] true:to_follow");
}
function evolve_venonat_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=venonat_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//venonat shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("venonat_s_fainted")){
            venonat_s_fainted(player)
			player.removeTag("venonat_s_fainted")
		}
  }
  function venonat_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_venonat_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_venonat_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:venonat_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:venonat_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//venomoth
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("venomoth_interact")){
            venomoth_interact(player)
			player.removeTag("venomoth_interact")
		}
  }
  function venomoth_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_venomoth(player)
        }
        if (result.selection === 1) {
            return_venomoth(player)
        }
        if (result.selection === 2) {
            follow_venomoth(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_venomoth(player) {
    player.runCommandAsync("event entity @e [family=venomoth,c=1,r=5] true:to_fight");
}
function return_venomoth(player) {
    player.runCommandAsync("event entity @e [family=venomoth,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:venomoth_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_venomoth(player) {
    player.runCommandAsync("event entity @e [family=venomoth,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//venomoth fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("venomoth_fainted")){
            venomoth_fainted(player)
			player.removeTag("venomoth_fainted")
		}
  }
  function venomoth_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_venomoth_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_venomoth_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:venomoth_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:venomoth_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//venomoth shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("venomoth_s_interact")){
            venomoth_s_interact(player)
			player.removeTag("venomoth_s_interact")
		}
  }
  function venomoth_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_venomoth_s(player)
        }
        if (result.selection === 1) {
            return_venomoth_s(player)
        }
        if (result.selection === 2) {
            follow_venomoth_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_venomoth_s(player) {
    player.runCommandAsync("event entity @e [family=venomoth_s,c=1,r=5] true:to_fight");
}
function return_venomoth_s(player) {
    player.runCommandAsync("event entity @e [family=venomoth_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:venomoth_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_venomoth_s(player) {
    player.runCommandAsync("event entity @e [family=venomoth_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//venomoth shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("venomoth_s_fainted")){
            venomoth_s_fainted(player)
			player.removeTag("venomoth_s_fainted")
		}
  }
  function venomoth_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_venomoth_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_venomoth_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:venomoth_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:venomoth_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//diglett
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("diglett_interact")){
            diglett_interact(player)
			player.removeTag("diglett_interact")
		}
  }
  function diglett_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_diglett(player)
        }
        if (result.selection === 1) {
            return_diglett(player)
        }
        if (result.selection === 2) {
            follow_diglett(player)
        }
        if (result.selection === 3) {
            evolve_diglett(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_diglett(player) {
    player.runCommandAsync("event entity @e [family=diglett,c=1,r=5] true:to_fight");
}
function return_diglett(player) {
    player.runCommandAsync("event entity @e [family=diglett,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:diglett_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_diglett(player) {
    player.runCommandAsync("event entity @e [family=diglett,c=1,r=5] true:to_follow");
}
function evolve_diglett (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=diglett,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//diglett fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("diglett_fainted")){
            diglett_fainted(player)
			player.removeTag("diglett_fainted")
		}
  }
  function diglett_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_diglett_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_diglett_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:diglett_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:diglett_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//diglett shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("diglett_s_interact")){
            diglett_s_interact(player)
			player.removeTag("diglett_s_interact")
		}
  }
  function diglett_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_diglett_s(player)
        }
        if (result.selection === 1) {
            return_diglett_s(player)
        }
        if (result.selection === 2) {
            follow_diglett_s(player)
        }
        if (result.selection === 3) {
            evolve_diglett_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_diglett_s(player) {
    player.runCommandAsync("event entity @e [family=diglett_s,c=1,r=5] true:to_fight");
}
function return_diglett_s(player) {
    player.runCommandAsync("event entity @e [family=diglett_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:diglett_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_diglett_s(player) {
    player.runCommandAsync("event entity @e [family=diglett_s,c=1,r=5] true:to_follow");
}
function evolve_diglett_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=diglett_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//diglett shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("diglett_s_fainted")){
            diglett_s_fainted(player)
			player.removeTag("diglett_s_fainted")
		}
  }
  function diglett_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_diglett_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_diglett_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:diglett_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:diglett_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//dugtrio
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("dugtrio_interact")){
            dugtrio_interact(player)
			player.removeTag("dugtrio_interact")
		}
  }
  function dugtrio_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_dugtrio(player)
        }
        if (result.selection === 1) {
            return_dugtrio(player)
        }
        if (result.selection === 2) {
            follow_dugtrio(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_dugtrio(player) {
    player.runCommandAsync("event entity @e [family=dugtrio,c=1,r=5] true:to_fight");
}
function return_dugtrio(player) {
    player.runCommandAsync("event entity @e [family=dugtrio,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:dugtrio_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_dugtrio(player) {
    player.runCommandAsync("event entity @e [family=dugtrio,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//dugtrio fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("dugtrio_fainted")){
            dugtrio_fainted(player)
			player.removeTag("dugtrio_fainted")
		}
  }
  function dugtrio_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_dugtrio_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_dugtrio_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:dugtrio_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:dugtrio_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//dugtrio shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("dugtrio_s_interact")){
            dugtrio_s_interact(player)
			player.removeTag("dugtrio_s_interact")
		}
  }
  function dugtrio_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_dugtrio_s(player)
        }
        if (result.selection === 1) {
            return_dugtrio_s(player)
        }
        if (result.selection === 2) {
            follow_dugtrio_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_dugtrio_s(player) {
    player.runCommandAsync("event entity @e [family=dugtrio_s,c=1,r=5] true:to_fight");
}
function return_dugtrio_s(player) {
    player.runCommandAsync("event entity @e [family=dugtrio_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:dugtrio_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_dugtrio_s(player) {
    player.runCommandAsync("event entity @e [family=dugtrio_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//dugtrio shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("dugtrio_s_fainted")){
            dugtrio_s_fainted(player)
			player.removeTag("dugtrio_s_fainted")
		}
  }
  function dugtrio_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_dugtrio_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_dugtrio_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:dugtrio_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:dugtrio_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//meowth
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("meowth_interact")){
            meowth_interact(player)
			player.removeTag("meowth_interact")
		}
  }
  function meowth_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_meowth(player)
        }
        if (result.selection === 1) {
            return_meowth(player)
        }
        if (result.selection === 2) {
            follow_meowth(player)
        }
        if (result.selection === 3) {
            evolve_meowth(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_meowth(player) {
    player.runCommandAsync("event entity @e [family=meowth,c=1,r=5] true:to_fight");
}
function return_meowth(player) {
    player.runCommandAsync("event entity @e [family=meowth,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:meowth_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_meowth(player) {
    player.runCommandAsync("event entity @e [family=meowth,c=1,r=5] true:to_follow");
}
function evolve_meowth (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=meowth,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//meowth fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("meowth_fainted")){
            meowth_fainted(player)
			player.removeTag("meowth_fainted")
		}
  }
  function meowth_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_meowth_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_meowth_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:meowth_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:meowth_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//meowth shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("meowth_s_interact")){
            meowth_s_interact(player)
			player.removeTag("meowth_s_interact")
		}
  }
  function meowth_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_meowth_s(player)
        }
        if (result.selection === 1) {
            return_meowth_s(player)
        }
        if (result.selection === 2) {
            follow_meowth_s(player)
        }
        if (result.selection === 3) {
            evolve_meowth_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_meowth_s(player) {
    player.runCommandAsync("event entity @e [family=meowth_s,c=1,r=5] true:to_fight");
}
function return_meowth_s(player) {
    player.runCommandAsync("event entity @e [family=meowth_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:meowth_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_meowth_s(player) {
    player.runCommandAsync("event entity @e [family=meowth_s,c=1,r=5] true:to_follow");
}
function evolve_meowth_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=meowth_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//meowth shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("meowth_s_fainted")){
            meowth_s_fainted(player)
			player.removeTag("meowth_s_fainted")
		}
  }
  function meowth_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_meowth_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_meowth_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:meowth_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:meowth_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//persian
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("persian_interact")){
            persian_interact(player)
			player.removeTag("persian_interact")
		}
  }
  function persian_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_persian(player)
        }
        if (result.selection === 1) {
            return_persian(player)
        }
        if (result.selection === 2) {
            follow_persian(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_persian(player) {
    player.runCommandAsync("event entity @e [family=persian,c=1,r=5] true:to_fight");
}
function return_persian(player) {
    player.runCommandAsync("event entity @e [family=persian,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:persian_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_persian(player) {
    player.runCommandAsync("event entity @e [family=persian,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//persian fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("persian_fainted")){
            persian_fainted(player)
			player.removeTag("persian_fainted")
		}
  }
  function persian_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_persian_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_persian_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:persian_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:persian_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//persian shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("persian_s_interact")){
            persian_s_interact(player)
			player.removeTag("persian_s_interact")
		}
  }
  function persian_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_persian_s(player)
        }
        if (result.selection === 1) {
            return_persian_s(player)
        }
        if (result.selection === 2) {
            follow_persian_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_persian_s(player) {
    player.runCommandAsync("event entity @e [family=persian_s,c=1,r=5] true:to_fight");
}
function return_persian_s(player) {
    player.runCommandAsync("event entity @e [family=persian_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:persian_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_persian_s(player) {
    player.runCommandAsync("event entity @e [family=persian_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//persian shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("persian_s_fainted")){
            persian_s_fainted(player)
			player.removeTag("persian_s_fainted")
		}
  }
  function persian_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_persian_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_persian_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:persian_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:persian_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//psyduck
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("psyduck_interact")){
            psyduck_interact(player)
			player.removeTag("psyduck_interact")
		}
  }
  function psyduck_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_psyduck(player)
        }
        if (result.selection === 1) {
            return_psyduck(player)
        }
        if (result.selection === 2) {
            follow_psyduck(player)
        }
        if (result.selection === 3) {
            evolve_psyduck(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_psyduck(player) {
    player.runCommandAsync("event entity @e [family=psyduck,c=1,r=5] true:to_fight");
}
function return_psyduck(player) {
    player.runCommandAsync("event entity @e [family=psyduck,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:psyduck_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_psyduck(player) {
    player.runCommandAsync("event entity @e [family=psyduck,c=1,r=5] true:to_follow");
}
function evolve_psyduck (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=psyduck,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//psyduck fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("psyduck_fainted")){
            psyduck_fainted(player)
			player.removeTag("psyduck_fainted")
		}
  }
  function psyduck_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_psyduck_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_psyduck_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:psyduck_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:psyduck_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//psyduck shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("psyduck_s_interact")){
            psyduck_s_interact(player)
			player.removeTag("psyduck_s_interact")
		}
  }
  function psyduck_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_psyduck_s(player)
        }
        if (result.selection === 1) {
            return_psyduck_s(player)
        }
        if (result.selection === 2) {
            follow_psyduck_s(player)
        }
        if (result.selection === 3) {
            evolve_psyduck_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_psyduck_s(player) {
    player.runCommandAsync("event entity @e [family=psyduck_s,c=1,r=5] true:to_fight");
}
function return_psyduck_s(player) {
    player.runCommandAsync("event entity @e [family=psyduck_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:psyduck_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_psyduck_s(player) {
    player.runCommandAsync("event entity @e [family=psyduck_s,c=1,r=5] true:to_follow");
}
function evolve_psyduck_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=psyduck_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//psyduck shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("psyduck_s_fainted")){
            psyduck_s_fainted(player)
			player.removeTag("psyduck_s_fainted")
		}
  }
  function psyduck_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_psyduck_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_psyduck_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:psyduck_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:psyduck_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//golduck
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("golduck_interact")){
            golduck_interact(player)
			player.removeTag("golduck_interact")
		}
  }
  function golduck_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_golduck(player)
        }
        if (result.selection === 1) {
            return_golduck(player)
        }
        if (result.selection === 2) {
            follow_golduck(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_golduck(player) {
    player.runCommandAsync("event entity @e [family=golduck,c=1,r=5] true:to_fight");
}
function return_golduck(player) {
    player.runCommandAsync("event entity @e [family=golduck,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:golduck_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_golduck(player) {
    player.runCommandAsync("event entity @e [family=golduck,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//golduck fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("golduck_fainted")){
            golduck_fainted(player)
			player.removeTag("golduck_fainted")
		}
  }
  function golduck_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_golduck_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_golduck_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:golduck_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:golduck_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//golduck shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("golduck_s_interact")){
            golduck_s_interact(player)
			player.removeTag("golduck_s_interact")
		}
  }
  function golduck_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_golduck_s(player)
        }
        if (result.selection === 1) {
            return_golduck_s(player)
        }
        if (result.selection === 2) {
            follow_golduck_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_golduck_s(player) {
    player.runCommandAsync("event entity @e [family=golduck_s,c=1,r=5] true:to_fight");
}
function return_golduck_s(player) {
    player.runCommandAsync("event entity @e [family=golduck_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:golduck_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_golduck_s(player) {
    player.runCommandAsync("event entity @e [family=golduck_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//golduck shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("golduck_s_fainted")){
            golduck_s_fainted(player)
			player.removeTag("golduck_s_fainted")
		}
  }
  function golduck_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_golduck_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_golduck_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:golduck_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:golduck_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//mankey
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("mankey_interact")){
            mankey_interact(player)
			player.removeTag("mankey_interact")
		}
  }
  function mankey_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_mankey(player)
        }
        if (result.selection === 1) {
            return_mankey(player)
        }
        if (result.selection === 2) {
            follow_mankey(player)
        }
        if (result.selection === 3) {
            evolve_mankey(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_mankey(player) {
    player.runCommandAsync("event entity @e [family=mankey,c=1,r=5] true:to_fight");
}
function return_mankey(player) {
    player.runCommandAsync("event entity @e [family=mankey,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:mankey_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_mankey(player) {
    player.runCommandAsync("event entity @e [family=mankey,c=1,r=5] true:to_follow");
}
function evolve_mankey (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=mankey,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//mankey fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("mankey_fainted")){
            mankey_fainted(player)
			player.removeTag("mankey_fainted")
		}
  }
  function mankey_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_mankey_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_mankey_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:mankey_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:mankey_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//mankey shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("mankey_s_interact")){
            mankey_s_interact(player)
			player.removeTag("mankey_s_interact")
		}
  }
  function mankey_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_mankey_s(player)
        }
        if (result.selection === 1) {
            return_mankey_s(player)
        }
        if (result.selection === 2) {
            follow_mankey_s(player)
        }
        if (result.selection === 3) {
            evolve_mankey_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_mankey_s(player) {
    player.runCommandAsync("event entity @e [family=mankey_s,c=1,r=5] true:to_fight");
}
function return_mankey_s(player) {
    player.runCommandAsync("event entity @e [family=mankey_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:mankey_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_mankey_s(player) {
    player.runCommandAsync("event entity @e [family=mankey_s,c=1,r=5] true:to_follow");
}
function evolve_mankey_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=mankey_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//mankey shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("mankey_s_fainted")){
            mankey_s_fainted(player)
			player.removeTag("mankey_s_fainted")
		}
  }
  function mankey_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_mankey_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_mankey_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:mankey_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:mankey_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//primeape
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("primeape_interact")){
            primeape_interact(player)
			player.removeTag("primeape_interact")
		}
  }
  function primeape_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_primeape(player)
        }
        if (result.selection === 1) {
            return_primeape(player)
        }
        if (result.selection === 2) {
            follow_primeape(player)
        }
        if (result.selection === 3) {
            evolve_primeape(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_primeape(player) {
    player.runCommandAsync("event entity @e [family=primeape,c=1,r=5] true:to_fight");
}
function return_primeape(player) {
    player.runCommandAsync("event entity @e [family=primeape,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:primeape_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_primeape(player) {
    player.runCommandAsync("event entity @e [family=primeape,c=1,r=5] true:to_follow");
}
function evolve_primeape (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("friendship")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("friendship")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=primeape,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:friendship 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//primeape fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("primeape_fainted")){
            primeape_fainted(player)
			player.removeTag("primeape_fainted")
		}
  }
  function primeape_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_primeape_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_primeape_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:primeape_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:primeape_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//primeape shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("primeape_s_interact")){
            primeape_s_interact(player)
			player.removeTag("primeape_s_interact")
		}
  }
  function primeape_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_primeape_s(player)
        }
        if (result.selection === 1) {
            return_primeape_s(player)
        }
        if (result.selection === 2) {
            follow_primeape_s(player)
        }
        if (result.selection === 3) {
            evolve_primeape_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_primeape_s(player) {
    player.runCommandAsync("event entity @e [family=primeape_s,c=1,r=5] true:to_fight");
}
function return_primeape_s(player) {
    player.runCommandAsync("event entity @e [family=primeape_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:primeape_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_primeape_s(player) {
    player.runCommandAsync("event entity @e [family=primeape_s,c=1,r=5] true:to_follow");
}
function evolve_primeape_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("friendship")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("friendship")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=primeape_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:friendship 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//primeape shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("primeape_s_fainted")){
            primeape_s_fainted(player)
			player.removeTag("primeape_s_fainted")
		}
  }
  function primeape_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_primeape_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_primeape_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:primeape_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:primeape_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//growlithe
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("growlithe_interact")){
            growlithe_interact(player)
			player.removeTag("growlithe_interact")
		}
  }
  function growlithe_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_growlithe(player)
        }
        if (result.selection === 1) {
            return_growlithe(player)
        }
        if (result.selection === 2) {
            follow_growlithe(player)
        }
        if (result.selection === 3) {
            evolve_growlithe(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_growlithe(player) {
    player.runCommandAsync("event entity @e [family=growlithe,c=1,r=5] true:to_fight");
}
function return_growlithe(player) {
    player.runCommandAsync("event entity @e [family=growlithe,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:growlithe_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_growlithe(player) {
    player.runCommandAsync("event entity @e [family=growlithe,c=1,r=5] true:to_follow");
}
function evolve_growlithe (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("fire_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("fire_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=growlithe,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:fire_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//growlithe fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("growlithe_fainted")){
            growlithe_fainted(player)
			player.removeTag("growlithe_fainted")
		}
  }
  function growlithe_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_growlithe_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_growlithe_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:growlithe_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:growlithe_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//growlithe shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("growlithe_s_interact")){
            growlithe_s_interact(player)
			player.removeTag("growlithe_s_interact")
		}
  }
  function growlithe_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_growlithe_s(player)
        }
        if (result.selection === 1) {
            return_growlithe_s(player)
        }
        if (result.selection === 2) {
            follow_growlithe_s(player)
        }
        if (result.selection === 3) {
            evolve_growlithe_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_growlithe_s(player) {
    player.runCommandAsync("event entity @e [family=growlithe_s,c=1,r=5] true:to_fight");
}
function return_growlithe_s(player) {
    player.runCommandAsync("event entity @e [family=growlithe_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:growlithe_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_growlithe_s(player) {
    player.runCommandAsync("event entity @e [family=growlithe_s,c=1,r=5] true:to_follow");
}
function evolve_growlithe_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("fire_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("fire_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=growlithe_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:fire_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//growlithe shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("growlithe_s_fainted")){
            growlithe_s_fainted(player)
			player.removeTag("growlithe_s_fainted")
		}
  }
  function growlithe_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_growlithe_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_growlithe_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:growlithe_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:growlithe_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//arcanine
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("arcanine_interact")){
            arcanine_interact(player)
			player.removeTag("arcanine_interact")
		}
  }
  function arcanine_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_arcanine(player)
        }
        if (result.selection === 1) {
            return_arcanine(player)
        }
        if (result.selection === 2) {
            follow_arcanine(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_arcanine(player) {
    player.runCommandAsync("event entity @e [family=arcanine,c=1,r=5] true:to_fight");
}
function return_arcanine(player) {
    player.runCommandAsync("event entity @e [family=arcanine,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:arcanine_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_arcanine(player) {
    player.runCommandAsync("event entity @e [family=arcanine,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//arcanine fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("arcanine_fainted")){
            arcanine_fainted(player)
			player.removeTag("arcanine_fainted")
		}
  }
  function arcanine_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_arcanine_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_arcanine_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:arcanine_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:arcanine_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//arcanine shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("arcanine_s_interact")){
            arcanine_s_interact(player)
			player.removeTag("arcanine_s_interact")
		}
  }
  function arcanine_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_arcanine_s(player)
        }
        if (result.selection === 1) {
            return_arcanine_s(player)
        }
        if (result.selection === 2) {
            follow_arcanine_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_arcanine_s(player) {
    player.runCommandAsync("event entity @e [family=arcanine_s,c=1,r=5] true:to_fight");
}
function return_arcanine_s(player) {
    player.runCommandAsync("event entity @e [family=arcanine_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:arcanine_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_arcanine_s(player) {
    player.runCommandAsync("event entity @e [family=arcanine_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//arcanine shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("arcanine_s_fainted")){
            arcanine_s_fainted(player)
			player.removeTag("arcanine_s_fainted")
		}
  }
  function arcanine_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_arcanine_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_arcanine_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:arcanine_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:arcanine_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//poliwag
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("poliwag_interact")){
            poliwag_interact(player)
			player.removeTag("poliwag_interact")
		}
  }
  function poliwag_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_poliwag(player)
        }
        if (result.selection === 1) {
            return_poliwag(player)
        }
        if (result.selection === 2) {
            follow_poliwag(player)
        }
        if (result.selection === 3) {
            evolve_poliwag(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_poliwag(player) {
    player.runCommandAsync("event entity @e [family=poliwag,c=1,r=5] true:to_fight");
}
function return_poliwag(player) {
    player.runCommandAsync("event entity @e [family=poliwag,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:poliwag_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_poliwag(player) {
    player.runCommandAsync("event entity @e [family=poliwag,c=1,r=5] true:to_follow");
}
function evolve_poliwag (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=poliwag,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//poliwag fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("poliwag_fainted")){
            poliwag_fainted(player)
			player.removeTag("poliwag_fainted")
		}
  }
  function poliwag_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_poliwag_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_poliwag_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:poliwag_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:poliwag_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//poliwag shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("poliwag_s_interact")){
            poliwag_s_interact(player)
			player.removeTag("poliwag_s_interact")
		}
  }
  function poliwag_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_poliwag_s(player)
        }
        if (result.selection === 1) {
            return_poliwag_s(player)
        }
        if (result.selection === 2) {
            follow_poliwag_s(player)
        }
        if (result.selection === 3) {
            evolve_poliwag_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_poliwag_s(player) {
    player.runCommandAsync("event entity @e [family=poliwag_s,c=1,r=5] true:to_fight");
}
function return_poliwag_s(player) {
    player.runCommandAsync("event entity @e [family=poliwag_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:poliwag_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_poliwag_s(player) {
    player.runCommandAsync("event entity @e [family=poliwag_s,c=1,r=5] true:to_follow");
}
function evolve_poliwag_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=poliwag_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//poliwag shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("poliwag_s_fainted")){
            poliwag_s_fainted(player)
			player.removeTag("poliwag_s_fainted")
		}
  }
  function poliwag_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_poliwag_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_poliwag_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:poliwag_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:poliwag_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//poliwhirl
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("poliwhirl_interact")){
            poliwhirl_interact(player)
			player.removeTag("poliwhirl_interact")
		}
  }
  function poliwhirl_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_poliwhirl(player)
        }
        if (result.selection === 1) {
            return_poliwhirl(player)
        }
        if (result.selection === 2) {
            follow_poliwhirl(player)
        }
        if (result.selection === 3) {
            evolve_poliwhirl(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_poliwhirl(player) {
    player.runCommandAsync("event entity @e [family=poliwhirl,c=1,r=5] true:to_fight");
}
function return_poliwhirl(player) {
    player.runCommandAsync("event entity @e [family=poliwhirl,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:poliwhirl_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_poliwhirl(player) {
    player.runCommandAsync("event entity @e [family=poliwhirl,c=1,r=5] true:to_follow");
}
function evolve_poliwhirl (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('POLIWRATH!', 'textures/gui/menu/pokemon/poliwrath_icon')
    gui.button('POLITOED!', 'textures/gui/menu/pokemon/politoed_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("water_stone")) {
            evolution_confirm_poliwrath(player)
        }
        if (result.selection === 0 && !player.hasTag("water_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1 && player.hasTag("kings_rock")) {
            evolution_confirm_politoed(player)
        }
        if (result.selection === 1 && !player.hasTag("kings_rock")) {
            evolution_denied(player)
        }
        if (result.selection === 2) {
            exit(player)
        }
    }
)
}
function evolution_confirm_poliwrath(player) {
    player.runCommandAsync("event entity @e [family=poliwhirl,c=1,r=5] true:to_evolve_poliwrath");
    player.runCommandAsync("clear @s true:water_stone 0 1");
}
function evolution_confirm_politoed(player) {
    player.runCommandAsync("event entity @e [family=poliwhirl,c=1,r=5] true:to_evolve_politoed");
    player.runCommandAsync("clear @s true:sun_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//poliwhirl fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("poliwhirl_fainted")){
            poliwhirl_fainted(player)
			player.removeTag("poliwhirl_fainted")
		}
  }
  function poliwhirl_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_poliwhirl_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_poliwhirl_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:poliwhirl_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:poliwhirl_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//poliwhirl shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("poliwhirl_s_interact")){
            poliwhirl_s_interact(player)
			player.removeTag("poliwhirl_s_interact")
		}
  }
  function poliwhirl_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_poliwhirl_s(player)
        }
        if (result.selection === 1) {
            return_poliwhirl_s(player)
        }
        if (result.selection === 2) {
            follow_poliwhirl_s(player)
        }
        if (result.selection === 3) {
            evolve_poliwhirl_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_poliwhirl_s(player) {
    player.runCommandAsync("event entity @e [family=poliwhirl_s,c=1,r=5] true:to_fight");
}
function return_poliwhirl_s(player) {
    player.runCommandAsync("event entity @e [family=poliwhirl_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:poliwhirl_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_poliwhirl_s(player) {
    player.runCommandAsync("event entity @e [family=poliwhirl_s,c=1,r=5] true:to_follow");
}
function evolve_poliwhirl_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('POLIWRATH!', 'textures/gui/menu/pokemon/poliwrath_s_icon')
    gui.button('POLITOED!', 'textures/gui/menu/pokemon/politoed_s_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("water_stone")) {
            evolution_confirm_poliwrath(player)
        }
        if (result.selection === 0 && !player.hasTag("water_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1 && player.hasTag("kings_rock")) {
            evolution_confirm_politoed(player)
        }
        if (result.selection === 1 && !player.hasTag("kings_rock")) {
            evolution_denied(player)
        }
        if (result.selection === 2) {
            exit(player)
        }
    }
)
}
function evolution_confirm_poliwrath(player) {
    player.runCommandAsync("event entity @e [family=poliwhirl_s,c=1,r=5] true:to_evolve_poliwrath");
    player.runCommandAsync("clear @s true:water_stone 0 1");
}
function evolution_confirm_politoed(player) {
    player.runCommandAsync("event entity @e [family=poliwhirl_s,c=1,r=5] true:to_evolve_politoed");
    player.runCommandAsync("clear @s true:sun_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//poliwhirl shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("poliwhirl_s_fainted")){
            poliwhirl_s_fainted(player)
			player.removeTag("poliwhirl_s_fainted")
		}
  }
  function poliwhirl_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_poliwhirl_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_poliwhirl_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:poliwhirl_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:poliwhirl_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//poliwrath
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("poliwrath_interact")){
            poliwrath_interact(player)
			player.removeTag("poliwrath_interact")
		}
  }
  function poliwrath_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_poliwrath(player)
        }
        if (result.selection === 1) {
            return_poliwrath(player)
        }
        if (result.selection === 2) {
            follow_poliwrath(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_poliwrath(player) {
    player.runCommandAsync("event entity @e [family=poliwrath,c=1,r=5] true:to_fight");
}
function return_poliwrath(player) {
    player.runCommandAsync("event entity @e [family=poliwrath,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:poliwrath_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_poliwrath(player) {
    player.runCommandAsync("event entity @e [family=poliwrath,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//poliwrath fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("poliwrath_fainted")){
            poliwrath_fainted(player)
			player.removeTag("poliwrath_fainted")
		}
  }
  function poliwrath_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_poliwrath_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_poliwrath_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:poliwrath_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:poliwrath_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//poliwrath shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("poliwrath_s_interact")){
            poliwrath_s_interact(player)
			player.removeTag("poliwrath_s_interact")
		}
  }
  function poliwrath_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_poliwrath_s(player)
        }
        if (result.selection === 1) {
            return_poliwrath_s(player)
        }
        if (result.selection === 2) {
            follow_poliwrath_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_poliwrath_s(player) {
    player.runCommandAsync("event entity @e [family=poliwrath_s,c=1,r=5] true:to_fight");
}
function return_poliwrath_s(player) {
    player.runCommandAsync("event entity @e [family=poliwrath_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:poliwrath_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_poliwrath_s(player) {
    player.runCommandAsync("event entity @e [family=poliwrath_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//poliwrath shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("poliwrath_s_fainted")){
            poliwrath_s_fainted(player)
			player.removeTag("poliwrath_s_fainted")
		}
  }
  function poliwrath_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_poliwrath_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_poliwrath_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:poliwrath_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:poliwrath_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//abra
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("abra_interact")){
            abra_interact(player)
			player.removeTag("abra_interact")
		}
  }
  function abra_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_abra(player)
        }
        if (result.selection === 1) {
            return_abra(player)
        }
        if (result.selection === 2) {
            follow_abra(player)
        }
        if (result.selection === 3) {
            evolve_abra(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_abra(player) {
    player.runCommandAsync("event entity @e [family=abra,c=1,r=5] true:to_fight");
}
function return_abra(player) {
    player.runCommandAsync("event entity @e [family=abra,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:abra_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_abra(player) {
    player.runCommandAsync("event entity @e [family=abra,c=1,r=5] true:to_follow");
}
function evolve_abra (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=abra,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//abra fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("abra_fainted")){
            abra_fainted(player)
			player.removeTag("abra_fainted")
		}
  }
  function abra_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_abra_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_abra_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:abra_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:abra_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//abra shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("abra_s_interact")){
            abra_s_interact(player)
			player.removeTag("abra_s_interact")
		}
  }
  function abra_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_abra_s(player)
        }
        if (result.selection === 1) {
            return_abra_s(player)
        }
        if (result.selection === 2) {
            follow_abra_s(player)
        }
        if (result.selection === 3) {
            evolve_abra_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_abra_s(player) {
    player.runCommandAsync("event entity @e [family=abra_s,c=1,r=5] true:to_fight");
}
function return_abra_s(player) {
    player.runCommandAsync("event entity @e [family=abra_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:abra_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_abra_s(player) {
    player.runCommandAsync("event entity @e [family=abra_s,c=1,r=5] true:to_follow");
}
function evolve_abra_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=abra_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//abra shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("abra_s_fainted")){
            abra_s_fainted(player)
			player.removeTag("abra_s_fainted")
		}
  }
  function abra_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_abra_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_abra_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:abra_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:abra_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//kadabra
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("kadabra_interact")){
            kadabra_interact(player)
			player.removeTag("kadabra_interact")
		}
  }
  function kadabra_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_kadabra(player)
        }
        if (result.selection === 1) {
            return_kadabra(player)
        }
        if (result.selection === 2) {
            follow_kadabra(player)
        }
        if (result.selection === 3) {
            evolve_kadabra(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_kadabra(player) {
    player.runCommandAsync("event entity @e [family=kadabra,c=1,r=5] true:to_fight");
}
function return_kadabra(player) {
    player.runCommandAsync("event entity @e [family=kadabra,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:kadabra_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_kadabra(player) {
    player.runCommandAsync("event entity @e [family=kadabra,c=1,r=5] true:to_follow");
}
function evolve_kadabra (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=kadabra,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//kadabra fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("kadabra_fainted")){
            kadabra_fainted(player)
			player.removeTag("kadabra_fainted")
		}
  }
  function kadabra_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_kadabra_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_kadabra_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:kadabra_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:kadabra_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//kadabra shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("kadabra_s_interact")){
            kadabra_s_interact(player)
			player.removeTag("kadabra_s_interact")
		}
  }
  function kadabra_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_kadabra_s(player)
        }
        if (result.selection === 1) {
            return_kadabra_s(player)
        }
        if (result.selection === 2) {
            follow_kadabra_s(player)
        }
        if (result.selection === 3) {
            evolve_kadabra_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_kadabra_s(player) {
    player.runCommandAsync("event entity @e [family=kadabra_s,c=1,r=5] true:to_fight");
}
function return_kadabra_s(player) {
    player.runCommandAsync("event entity @e [family=kadabra_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:kadabra_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_kadabra_s(player) {
    player.runCommandAsync("event entity @e [family=kadabra_s,c=1,r=5] true:to_follow");
}
function evolve_kadabra_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=kadabra_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//kadabra shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("kadabra_s_fainted")){
            kadabra_s_fainted(player)
			player.removeTag("kadabra_s_fainted")
		}
  }
  function kadabra_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_kadabra_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_kadabra_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:kadabra_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:kadabra_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//alakazam
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("alakazam_interact")){
            alakazam_interact(player)
			player.removeTag("alakazam_interact")
		}
  }
  function alakazam_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_alakazam(player)
        }
        if (result.selection === 1) {
            return_alakazam(player)
        }
        if (result.selection === 2) {
            follow_alakazam(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_alakazam(player) {
    player.runCommandAsync("event entity @e [family=alakazam,c=1,r=5] true:to_fight");
}
function return_alakazam(player) {
    player.runCommandAsync("event entity @e [family=alakazam,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:alakazam_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_alakazam(player) {
    player.runCommandAsync("event entity @e [family=alakazam,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//alakazam fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("alakazam_fainted")){
            alakazam_fainted(player)
			player.removeTag("alakazam_fainted")
		}
  }
  function alakazam_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_alakazam_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_alakazam_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:alakazam_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:alakazam_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//alakazam shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("alakazam_s_interact")){
            alakazam_s_interact(player)
			player.removeTag("alakazam_s_interact")
		}
  }
  function alakazam_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_alakazam_s(player)
        }
        if (result.selection === 1) {
            return_alakazam_s(player)
        }
        if (result.selection === 2) {
            follow_alakazam_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_alakazam_s(player) {
    player.runCommandAsync("event entity @e [family=alakazam_s,c=1,r=5] true:to_fight");
}
function return_alakazam_s(player) {
    player.runCommandAsync("event entity @e [family=alakazam_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:alakazam_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_alakazam_s(player) {
    player.runCommandAsync("event entity @e [family=alakazam_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//alakazam shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("alakazam_s_fainted")){
            alakazam_s_fainted(player)
			player.removeTag("alakazam_s_fainted")
		}
  }
  function alakazam_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_alakazam_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_alakazam_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:alakazam_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:alakazam_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//machop
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("machop_interact")){
            machop_interact(player)
			player.removeTag("machop_interact")
		}
  }
  function machop_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_machop(player)
        }
        if (result.selection === 1) {
            return_machop(player)
        }
        if (result.selection === 2) {
            follow_machop(player)
        }
        if (result.selection === 3) {
            evolve_machop(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_machop(player) {
    player.runCommandAsync("event entity @e [family=machop,c=1,r=5] true:to_fight");
}
function return_machop(player) {
    player.runCommandAsync("event entity @e [family=machop,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:machop_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_machop(player) {
    player.runCommandAsync("event entity @e [family=machop,c=1,r=5] true:to_follow");
}
function evolve_machop (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=machop,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//machop fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("machop_fainted")){
            machop_fainted(player)
			player.removeTag("machop_fainted")
		}
  }
  function machop_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_machop_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_machop_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:machop_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:machop_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//machop shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("machop_s_interact")){
            machop_s_interact(player)
			player.removeTag("machop_s_interact")
		}
  }
  function machop_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_machop_s(player)
        }
        if (result.selection === 1) {
            return_machop_s(player)
        }
        if (result.selection === 2) {
            follow_machop_s(player)
        }
        if (result.selection === 3) {
            evolve_machop_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_machop_s(player) {
    player.runCommandAsync("event entity @e [family=machop_s,c=1,r=5] true:to_fight");
}
function return_machop_s(player) {
    player.runCommandAsync("event entity @e [family=machop_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:machop_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_machop_s(player) {
    player.runCommandAsync("event entity @e [family=machop_s,c=1,r=5] true:to_follow");
}
function evolve_machop_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=machop_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//machop shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("machop_s_fainted")){
            machop_s_fainted(player)
			player.removeTag("machop_s_fainted")
		}
  }
  function machop_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_machop_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_machop_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:machop_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:machop_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//machoke
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("machoke_interact")){
            machoke_interact(player)
			player.removeTag("machoke_interact")
		}
  }
  function machoke_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_machoke(player)
        }
        if (result.selection === 1) {
            return_machoke(player)
        }
        if (result.selection === 2) {
            follow_machoke(player)
        }
        if (result.selection === 3) {
            evolve_machoke(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_machoke(player) {
    player.runCommandAsync("event entity @e [family=machoke,c=1,r=5] true:to_fight");
}
function return_machoke(player) {
    player.runCommandAsync("event entity @e [family=machoke,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:machoke_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_machoke(player) {
    player.runCommandAsync("event entity @e [family=machoke,c=1,r=5] true:to_follow");
}
function evolve_machoke (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=machoke,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//machoke fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("machoke_fainted")){
            machoke_fainted(player)
			player.removeTag("machoke_fainted")
		}
  }
  function machoke_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_machoke_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_machoke_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:machoke_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:machoke_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//machoke shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("machoke_s_interact")){
            machoke_s_interact(player)
			player.removeTag("machoke_s_interact")
		}
  }
  function machoke_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_machoke_s(player)
        }
        if (result.selection === 1) {
            return_machoke_s(player)
        }
        if (result.selection === 2) {
            follow_machoke_s(player)
        }
        if (result.selection === 3) {
            evolve_machoke_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_machoke_s(player) {
    player.runCommandAsync("event entity @e [family=machoke_s,c=1,r=5] true:to_fight");
}
function return_machoke_s(player) {
    player.runCommandAsync("event entity @e [family=machoke_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:machoke_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_machoke_s(player) {
    player.runCommandAsync("event entity @e [family=machoke_s,c=1,r=5] true:to_follow");
}
function evolve_machoke_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=machoke_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//machoke shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("machoke_s_fainted")){
            machoke_s_fainted(player)
			player.removeTag("machoke_s_fainted")
		}
  }
  function machoke_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_machoke_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_machoke_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:machoke_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:machoke_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//machamp
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("machamp_interact")){
            machamp_interact(player)
			player.removeTag("machamp_interact")
		}
  }
  function machamp_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_machamp(player)
        }
        if (result.selection === 1) {
            return_machamp(player)
        }
        if (result.selection === 2) {
            follow_machamp(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_machamp(player) {
    player.runCommandAsync("event entity @e [family=machamp,c=1,r=5] true:to_fight");
}
function return_machamp(player) {
    player.runCommandAsync("event entity @e [family=machamp,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:machamp_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_machamp(player) {
    player.runCommandAsync("event entity @e [family=machamp,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//machamp fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("machamp_fainted")){
            machamp_fainted(player)
			player.removeTag("machamp_fainted")
		}
  }
  function machamp_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_machamp_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_machamp_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:machamp_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:machamp_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//machamp shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("machamp_s_interact")){
            machamp_s_interact(player)
			player.removeTag("machamp_s_interact")
		}
  }
  function machamp_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_machamp_s(player)
        }
        if (result.selection === 1) {
            return_machamp_s(player)
        }
        if (result.selection === 2) {
            follow_machamp_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_machamp_s(player) {
    player.runCommandAsync("event entity @e [family=machamp_s,c=1,r=5] true:to_fight");
}
function return_machamp_s(player) {
    player.runCommandAsync("event entity @e [family=machamp_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:machamp_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_machamp_s(player) {
    player.runCommandAsync("event entity @e [family=machamp_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//machamp shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("machamp_s_fainted")){
            machamp_s_fainted(player)
			player.removeTag("machamp_s_fainted")
		}
  }
  function machamp_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_machamp_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_machamp_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:machamp_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:machamp_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//bellsprout
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("bellsprout_interact")){
            bellsprout_interact(player)
			player.removeTag("bellsprout_interact")
		}
  }
  function bellsprout_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_bellsprout(player)
        }
        if (result.selection === 1) {
            return_bellsprout(player)
        }
        if (result.selection === 2) {
            follow_bellsprout(player)
        }
        if (result.selection === 3) {
            evolve_bellsprout(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_bellsprout(player) {
    player.runCommandAsync("event entity @e [family=bellsprout,c=1,r=5] true:to_fight");
}
function return_bellsprout(player) {
    player.runCommandAsync("event entity @e [family=bellsprout,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:bellsprout_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_bellsprout(player) {
    player.runCommandAsync("event entity @e [family=bellsprout,c=1,r=5] true:to_follow");
}
function evolve_bellsprout (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=bellsprout,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//bellsprout fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("bellsprout_fainted")){
            bellsprout_fainted(player)
			player.removeTag("bellsprout_fainted")
		}
  }
  function bellsprout_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_bellsprout_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_bellsprout_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:bellsprout_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:bellsprout_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//bellsprout shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("bellsprout_s_interact")){
            bellsprout_s_interact(player)
			player.removeTag("bellsprout_s_interact")
		}
  }
  function bellsprout_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_bellsprout_s(player)
        }
        if (result.selection === 1) {
            return_bellsprout_s(player)
        }
        if (result.selection === 2) {
            follow_bellsprout_s(player)
        }
        if (result.selection === 3) {
            evolve_bellsprout_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_bellsprout_s(player) {
    player.runCommandAsync("event entity @e [family=bellsprout_s,c=1,r=5] true:to_fight");
}
function return_bellsprout_s(player) {
    player.runCommandAsync("event entity @e [family=bellsprout_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:bellsprout_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_bellsprout_s(player) {
    player.runCommandAsync("event entity @e [family=bellsprout_s,c=1,r=5] true:to_follow");
}
function evolve_bellsprout_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=bellsprout_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//bellsprout shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("bellsprout_s_fainted")){
            bellsprout_s_fainted(player)
			player.removeTag("bellsprout_s_fainted")
		}
  }
  function bellsprout_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_bellsprout_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_bellsprout_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:bellsprout_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:bellsprout_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//weepinbell
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("weepinbell_interact")){
            weepinbell_interact(player)
			player.removeTag("weepinbell_interact")
		}
  }
  function weepinbell_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_weepinbell(player)
        }
        if (result.selection === 1) {
            return_weepinbell(player)
        }
        if (result.selection === 2) {
            follow_weepinbell(player)
        }
        if (result.selection === 3) {
            evolve_weepinbell(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_weepinbell(player) {
    player.runCommandAsync("event entity @e [family=weepinbell,c=1,r=5] true:to_fight");
}
function return_weepinbell(player) {
    player.runCommandAsync("event entity @e [family=weepinbell,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:weepinbell_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_weepinbell(player) {
    player.runCommandAsync("event entity @e [family=weepinbell,c=1,r=5] true:to_follow");
}
function evolve_weepinbell (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("leaf_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("leaf_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=weepinbell,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:leaf_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//weepinbell fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("weepinbell_fainted")){
            weepinbell_fainted(player)
			player.removeTag("weepinbell_fainted")
		}
  }
  function weepinbell_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_weepinbell_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_weepinbell_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:weepinbell_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:weepinbell_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//weepinbell shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("weepinbell_s_interact")){
            weepinbell_s_interact(player)
			player.removeTag("weepinbell_s_interact")
		}
  }
  function weepinbell_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_weepinbell_s(player)
        }
        if (result.selection === 1) {
            return_weepinbell_s(player)
        }
        if (result.selection === 2) {
            follow_weepinbell_s(player)
        }
        if (result.selection === 3) {
            evolve_weepinbell_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_weepinbell_s(player) {
    player.runCommandAsync("event entity @e [family=weepinbell_s,c=1,r=5] true:to_fight");
}
function return_weepinbell_s(player) {
    player.runCommandAsync("event entity @e [family=weepinbell_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:weepinbell_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_weepinbell_s(player) {
    player.runCommandAsync("event entity @e [family=weepinbell_s,c=1,r=5] true:to_follow");
}
function evolve_weepinbell_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("leaf_stone")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("leaf_stone")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=weepinbell_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("clear @s true:leaf_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//weepinbell shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("weepinbell_s_fainted")){
            weepinbell_s_fainted(player)
			player.removeTag("weepinbell_s_fainted")
		}
  }
  function weepinbell_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_weepinbell_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_weepinbell_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:weepinbell_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:weepinbell_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//victreebel
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("victreebel_interact")){
            victreebel_interact(player)
			player.removeTag("victreebel_interact")
		}
  }
  function victreebel_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_victreebel(player)
        }
        if (result.selection === 1) {
            return_victreebel(player)
        }
        if (result.selection === 2) {
            follow_victreebel(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_victreebel(player) {
    player.runCommandAsync("event entity @e [family=victreebel,c=1,r=5] true:to_fight");
}
function return_victreebel(player) {
    player.runCommandAsync("event entity @e [family=victreebel,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:victreebel_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_victreebel(player) {
    player.runCommandAsync("event entity @e [family=victreebel,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//victreebel fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("victreebel_fainted")){
            victreebel_fainted(player)
			player.removeTag("victreebel_fainted")
		}
  }
  function victreebel_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_victreebel_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_victreebel_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:victreebel_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:victreebel_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//victreebel shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("victreebel_s_interact")){
            victreebel_s_interact(player)
			player.removeTag("victreebel_s_interact")
		}
  }
  function victreebel_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_victreebel_s(player)
        }
        if (result.selection === 1) {
            return_victreebel_s(player)
        }
        if (result.selection === 2) {
            follow_victreebel_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_victreebel_s(player) {
    player.runCommandAsync("event entity @e [family=victreebel_s,c=1,r=5] true:to_fight");
}
function return_victreebel_s(player) {
    player.runCommandAsync("event entity @e [family=victreebel_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:victreebel_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_victreebel_s(player) {
    player.runCommandAsync("event entity @e [family=victreebel_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//victreebel shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("victreebel_s_fainted")){
            victreebel_s_fainted(player)
			player.removeTag("victreebel_s_fainted")
		}
  }
  function victreebel_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_victreebel_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_victreebel_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:victreebel_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:victreebel_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//tentacool
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("tentacool_interact")){
            tentacool_interact(player)
			player.removeTag("tentacool_interact")
		}
  }
  function tentacool_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_tentacool(player)
        }
        if (result.selection === 1) {
            return_tentacool(player)
        }
        if (result.selection === 2) {
            follow_tentacool(player)
        }
        if (result.selection === 3) {
            evolve_tentacool(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_tentacool(player) {
    player.runCommandAsync("event entity @e [family=tentacool,c=1,r=5] true:to_fight");
}
function return_tentacool(player) {
    player.runCommandAsync("event entity @e [family=tentacool,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:tentacool_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_tentacool(player) {
    player.runCommandAsync("event entity @e [family=tentacool,c=1,r=5] true:to_follow");
}
function evolve_tentacool (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=tentacool,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//tentacool fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("tentacool_fainted")){
            tentacool_fainted(player)
			player.removeTag("tentacool_fainted")
		}
  }
  function tentacool_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_tentacool_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_tentacool_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:tentacool_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:tentacool_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//tentacool shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("tentacool_s_interact")){
            tentacool_s_interact(player)
			player.removeTag("tentacool_s_interact")
		}
  }
  function tentacool_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_tentacool_s(player)
        }
        if (result.selection === 1) {
            return_tentacool_s(player)
        }
        if (result.selection === 2) {
            follow_tentacool_s(player)
        }
        if (result.selection === 3) {
            evolve_tentacool_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_tentacool_s(player) {
    player.runCommandAsync("event entity @e [family=tentacool_s,c=1,r=5] true:to_fight");
}
function return_tentacool_s(player) {
    player.runCommandAsync("event entity @e [family=tentacool_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:tentacool_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_tentacool_s(player) {
    player.runCommandAsync("event entity @e [family=tentacool_s,c=1,r=5] true:to_follow");
}
function evolve_tentacool_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=tentacool_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//tentacool shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("tentacool_s_fainted")){
            tentacool_s_fainted(player)
			player.removeTag("tentacool_s_fainted")
		}
  }
  function tentacool_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_tentacool_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_tentacool_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:tentacool_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:tentacool_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//tentacruel
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("tentacruel_interact")){
            tentacruel_interact(player)
			player.removeTag("tentacruel_interact")
		}
  }
  function tentacruel_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_tentacruel(player)
        }
        if (result.selection === 1) {
            return_tentacruel(player)
        }
        if (result.selection === 2) {
            follow_tentacruel(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_tentacruel(player) {
    player.runCommandAsync("event entity @e [family=tentacruel,c=1,r=5] true:to_fight");
}
function return_tentacruel(player) {
    player.runCommandAsync("event entity @e [family=tentacruel,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:tentacruel_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_tentacruel(player) {
    player.runCommandAsync("event entity @e [family=tentacruel,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//tentacruel fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("tentacruel_fainted")){
            tentacruel_fainted(player)
			player.removeTag("tentacruel_fainted")
		}
  }
  function tentacruel_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_tentacruel_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_tentacruel_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:tentacruel_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:tentacruel_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//tentacruel shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("tentacruel_s_interact")){
            tentacruel_s_interact(player)
			player.removeTag("tentacruel_s_interact")
		}
  }
  function tentacruel_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_tentacruel_s(player)
        }
        if (result.selection === 1) {
            return_tentacruel_s(player)
        }
        if (result.selection === 2) {
            follow_tentacruel_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_tentacruel_s(player) {
    player.runCommandAsync("event entity @e [family=tentacruel_s,c=1,r=5] true:to_fight");
}
function return_tentacruel_s(player) {
    player.runCommandAsync("event entity @e [family=tentacruel_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:tentacruel_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_tentacruel_s(player) {
    player.runCommandAsync("event entity @e [family=tentacruel_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//tentacruel shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("tentacruel_s_fainted")){
            tentacruel_s_fainted(player)
			player.removeTag("tentacruel_s_fainted")
		}
  }
  function tentacruel_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_tentacruel_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_tentacruel_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:tentacruel_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:tentacruel_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//geodude
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("geodude_interact")){
            geodude_interact(player)
			player.removeTag("geodude_interact")
		}
  }
  function geodude_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_geodude(player)
        }
        if (result.selection === 1) {
            return_geodude(player)
        }
        if (result.selection === 2) {
            follow_geodude(player)
        }
        if (result.selection === 3) {
            evolve_geodude(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_geodude(player) {
    player.runCommandAsync("event entity @e [family=geodude,c=1,r=5] true:to_fight");
}
function return_geodude(player) {
    player.runCommandAsync("event entity @e [family=geodude,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:geodude_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_geodude(player) {
    player.runCommandAsync("event entity @e [family=geodude,c=1,r=5] true:to_follow");
}
function evolve_geodude (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=geodude,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//geodude fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("geodude_fainted")){
            geodude_fainted(player)
			player.removeTag("geodude_fainted")
		}
  }
  function geodude_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_geodude_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_geodude_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:geodude_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:geodude_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//geodude shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("geodude_s_interact")){
            geodude_s_interact(player)
			player.removeTag("geodude_s_interact")
		}
  }
  function geodude_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_geodude_s(player)
        }
        if (result.selection === 1) {
            return_geodude_s(player)
        }
        if (result.selection === 2) {
            follow_geodude_s(player)
        }
        if (result.selection === 3) {
            evolve_geodude_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_geodude_s(player) {
    player.runCommandAsync("event entity @e [family=geodude_s,c=1,r=5] true:to_fight");
}
function return_geodude_s(player) {
    player.runCommandAsync("event entity @e [family=geodude_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:geodude_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_geodude_s(player) {
    player.runCommandAsync("event entity @e [family=geodude_s,c=1,r=5] true:to_follow");
}
function evolve_geodude_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=geodude_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//geodude shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("geodude_s_fainted")){
            geodude_s_fainted(player)
			player.removeTag("geodude_s_fainted")
		}
  }
  function geodude_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_geodude_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_geodude_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:geodude_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:geodude_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//graveler
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("graveler_interact")){
            graveler_interact(player)
			player.removeTag("graveler_interact")
		}
  }
  function graveler_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_graveler(player)
        }
        if (result.selection === 1) {
            return_graveler(player)
        }
        if (result.selection === 2) {
            follow_graveler(player)
        }
        if (result.selection === 3) {
            evolve_graveler(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_graveler(player) {
    player.runCommandAsync("event entity @e [family=graveler,c=1,r=5] true:to_fight");
}
function return_graveler(player) {
    player.runCommandAsync("event entity @e [family=graveler,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:graveler_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_graveler(player) {
    player.runCommandAsync("event entity @e [family=graveler,c=1,r=5] true:to_follow");
}
function evolve_graveler (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=graveler,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//graveler fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("graveler_fainted")){
            graveler_fainted(player)
			player.removeTag("graveler_fainted")
		}
  }
  function graveler_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_graveler_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_graveler_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:graveler_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:graveler_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//graveler shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("graveler_s_interact")){
            graveler_s_interact(player)
			player.removeTag("graveler_s_interact")
		}
  }
  function graveler_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_graveler_s(player)
        }
        if (result.selection === 1) {
            return_graveler_s(player)
        }
        if (result.selection === 2) {
            follow_graveler_s(player)
        }
        if (result.selection === 3) {
            evolve_graveler_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_graveler_s(player) {
    player.runCommandAsync("event entity @e [family=graveler_s,c=1,r=5] true:to_fight");
}
function return_graveler_s(player) {
    player.runCommandAsync("event entity @e [family=graveler_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:graveler_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_graveler_s(player) {
    player.runCommandAsync("event entity @e [family=graveler_s,c=1,r=5] true:to_follow");
}
function evolve_graveler_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=graveler_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//graveler shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("graveler_s_fainted")){
            graveler_s_fainted(player)
			player.removeTag("graveler_s_fainted")
		}
  }
  function graveler_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_graveler_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_graveler_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:graveler_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:graveler_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//golem
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("golem_interact")){
            golem_interact(player)
			player.removeTag("golem_interact")
		}
  }
  function golem_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_golem(player)
        }
        if (result.selection === 1) {
            return_golem(player)
        }
        if (result.selection === 2) {
            follow_golem(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_golem(player) {
    player.runCommandAsync("event entity @e [family=golem,c=1,r=5] true:to_fight");
}
function return_golem(player) {
    player.runCommandAsync("event entity @e [family=golem,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:golem_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_golem(player) {
    player.runCommandAsync("event entity @e [family=golem,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//golem fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("golem_fainted")){
            golem_fainted(player)
			player.removeTag("golem_fainted")
		}
  }
  function golem_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_golem_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_golem_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:golem_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:golem_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//golem shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("golem_s_interact")){
            golem_s_interact(player)
			player.removeTag("golem_s_interact")
		}
  }
  function golem_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_golem_s(player)
        }
        if (result.selection === 1) {
            return_golem_s(player)
        }
        if (result.selection === 2) {
            follow_golem_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_golem_s(player) {
    player.runCommandAsync("event entity @e [family=golem_s,c=1,r=5] true:to_fight");
}
function return_golem_s(player) {
    player.runCommandAsync("event entity @e [family=golem_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:golem_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_golem_s(player) {
    player.runCommandAsync("event entity @e [family=golem_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//golem shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("golem_s_fainted")){
            golem_s_fainted(player)
			player.removeTag("golem_s_fainted")
		}
  }
  function golem_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_golem_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_golem_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:golem_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:golem_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ponyta
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ponyta_interact")){
            ponyta_interact(player)
			player.removeTag("ponyta_interact")
		}
  }
  function ponyta_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_ponyta(player)
        }
        if (result.selection === 1) {
            return_ponyta(player)
        }
        if (result.selection === 2) {
            follow_ponyta(player)
        }
        if (result.selection === 3) {
            evolve_ponyta(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_ponyta(player) {
    player.runCommandAsync("event entity @e [family=ponyta,c=1,r=5] true:to_fight");
}
function return_ponyta(player) {
    player.runCommandAsync("event entity @e [family=ponyta,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ponyta_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_ponyta(player) {
    player.runCommandAsync("event entity @e [family=ponyta,c=1,r=5] true:to_follow");
}
function evolve_ponyta (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=ponyta,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ponyta fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ponyta_fainted")){
            ponyta_fainted(player)
			player.removeTag("ponyta_fainted")
		}
  }
  function ponyta_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_ponyta_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_ponyta_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:ponyta_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ponyta_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ponyta shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ponyta_s_interact")){
            ponyta_s_interact(player)
			player.removeTag("ponyta_s_interact")
		}
  }
  function ponyta_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_ponyta_s(player)
        }
        if (result.selection === 1) {
            return_ponyta_s(player)
        }
        if (result.selection === 2) {
            follow_ponyta_s(player)
        }
        if (result.selection === 3) {
            evolve_ponyta_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_ponyta_s(player) {
    player.runCommandAsync("event entity @e [family=ponyta_s,c=1,r=5] true:to_fight");
}
function return_ponyta_s(player) {
    player.runCommandAsync("event entity @e [family=ponyta_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ponyta_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_ponyta_s(player) {
    player.runCommandAsync("event entity @e [family=ponyta_s,c=1,r=5] true:to_follow");
}
function evolve_ponyta_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function evolution_confirm(player) {
    player.runCommandAsync("event entity @e [family=ponyta_s,c=1,r=5] true:to_evolve");
    player.runCommandAsync("xp -20L @s");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//ponyta shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("ponyta_s_fainted")){
            ponyta_s_fainted(player)
			player.removeTag("ponyta_s_fainted")
		}
  }
  function ponyta_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_ponyta_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_ponyta_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:ponyta_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:ponyta_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//rapidash
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("rapidash_interact")){
            rapidash_interact(player)
			player.removeTag("rapidash_interact")
		}
  }
  function rapidash_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_rapidash(player)
        }
        if (result.selection === 1) {
            return_rapidash(player)
        }
        if (result.selection === 2) {
            follow_rapidash(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_rapidash(player) {
    player.runCommandAsync("event entity @e [family=rapidash,c=1,r=5] true:to_fight");
}
function return_rapidash(player) {
    player.runCommandAsync("event entity @e [family=rapidash,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:rapidash_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_rapidash(player) {
    player.runCommandAsync("event entity @e [family=rapidash,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//rapidash fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("rapidash_fainted")){
            rapidash_fainted(player)
			player.removeTag("rapidash_fainted")
		}
  }
  function rapidash_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_rapidash_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_rapidash_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:rapidash_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:rapidash_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//rapidash shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("rapidash_s_interact")){
            rapidash_s_interact(player)
			player.removeTag("rapidash_s_interact")
		}
  }
  function rapidash_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_rapidash_s(player)
        }
        if (result.selection === 1) {
            return_rapidash_s(player)
        }
        if (result.selection === 2) {
            follow_rapidash_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_rapidash_s(player) {
    player.runCommandAsync("event entity @e [family=rapidash_s,c=1,r=5] true:to_fight");
}
function return_rapidash_s(player) {
    player.runCommandAsync("event entity @e [family=rapidash_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:rapidash_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_rapidash_s(player) {
    player.runCommandAsync("event entity @e [family=rapidash_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//rapidash shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("rapidash_s_fainted")){
            rapidash_s_fainted(player)
			player.removeTag("rapidash_s_fainted")
		}
  }
  function rapidash_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_rapidash_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_rapidash_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:rapidash_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:rapidash_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//slowpoke
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("slowpoke_interact")){
            slowpoke_interact(player)
			player.removeTag("slowpoke_interact")
		}
  }
  function slowpoke_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_slowpoke(player)
        }
        if (result.selection === 1) {
            return_slowpoke(player)
        }
        if (result.selection === 2) {
            follow_slowpoke(player)
        }
        if (result.selection === 3) {
            evolve_slowpoke(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_slowpoke(player) {
    player.runCommandAsync("event entity @e [family=slowpoke,c=1,r=5] true:to_fight");
}
function return_slowpoke(player) {
    player.runCommandAsync("event entity @e [family=slowpoke,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:slowpoke_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_slowpoke(player) {
    player.runCommandAsync("event entity @e [family=slowpoke,c=1,r=5] true:to_follow");
}
function evolve_slowpoke (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('Slowbro!', 'textures/gui/menu/pokemon/slowbro_icon')
    gui.button('Slowking!', 'textures/gui/menu/pokemon/slowking_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm_slowbro(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1 && player.hasTag("kings_rock")) {
            evolution_confirm_slowking(player)
        }
        if (result.selection === 1 && !player.hasTag("kings_rock")) {
            evolution_denied(player)
        }
        if (result.selection === 2) {
            exit(player)
        }
    }
)
}
function evolution_confirm_slowbro(player) {
    player.runCommandAsync("event entity @e [family=slowpoke,c=1,r=5] true:to_evolve_slowbro");
    player.runCommandAsync("xp -20L @s");
}
function evolution_confirm_slowking(player) {
    player.runCommandAsync("event entity @e [family=slowpoke,c=1,r=5] true:to_evolve_slowking");
    player.runCommandAsync("clear @s true:sun_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//slowpoke fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("slowpoke_fainted")){
            slowpoke_fainted(player)
			player.removeTag("slowpoke_fainted")
		}
  }
  function slowpoke_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_slowpoke_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_slowpoke_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:slowpoke_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:slowpoke_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//slowpoke shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("slowpoke_s_interact")){
            slowpoke_s_interact(player)
			player.removeTag("slowpoke_s_interact")
		}
  }
  function slowpoke_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EVOLVE!', 'textures/gui/menu/evolve_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_slowpoke_s(player)
        }
        if (result.selection === 1) {
            return_slowpoke_s(player)
        }
        if (result.selection === 2) {
            follow_slowpoke_s(player)
        }
        if (result.selection === 3) {
            evolve_slowpoke_s(player)
        }
        if (result.selection === 4) {
            exit(player)
        }
    }
)
}
function fight_slowpoke_s(player) {
    player.runCommandAsync("event entity @e [family=slowpoke_s,c=1,r=5] true:to_fight");
}
function return_slowpoke_s(player) {
    player.runCommandAsync("event entity @e [family=slowpoke_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:slowpoke_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_slowpoke_s(player) {
    player.runCommandAsync("event entity @e [family=slowpoke_s,c=1,r=5] true:to_follow");
}
function evolve_slowpoke_s (player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you want to Evolve your Pokemon?');
    gui.button('Slowbro!', 'textures/gui/menu/pokemon/slowbro_s_icon')
    gui.button('Slowking!', 'textures/gui/menu/pokemon/slowking_s_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0 && player.hasTag("evolve")) {
            evolution_confirm_slowbro(player)
        }
        if (result.selection === 0 && !player.hasTag("evolve")) {
            evolution_denied(player)
        }
        if (result.selection === 1 && player.hasTag("kings_rock")) {
            evolution_confirm_slowking(player)
        }
        if (result.selection === 1 && !player.hasTag("kings_rock")) {
            evolution_denied(player)
        }
        if (result.selection === 2) {
            exit(player)
        }
    }
)
}
function evolution_confirm_slowbro(player) {
    player.runCommandAsync("event entity @e [family=slowpoke_s,c=1,r=5] true:to_evolve_slowbro");
    player.runCommandAsync("xp -20L @s");
}
function evolution_confirm_slowking(player) {
    player.runCommandAsync("event entity @e [family=slowpoke_s,c=1,r=5] true:to_evolve_slowking");
    player.runCommandAsync("clear @s true:sun_stone 0 1");
}
function evolution_denied(player) {
    const gui = new ActionFormData();
    gui.body('You do not meet the requirements for this Pokemon to Evolve!');
    gui.button('Exit!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
  }
})
//slowpoke shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("slowpoke_s_fainted")){
            slowpoke_s_fainted(player)
			player.removeTag("slowpoke_s_fainted")
		}
  }
  function slowpoke_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_slowpoke_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_slowpoke_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:slowpoke_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:slowpoke_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//slowbro
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("slowbro_interact")){
            slowbro_interact(player)
			player.removeTag("slowbro_interact")
		}
  }
  function slowbro_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_slowbro(player)
        }
        if (result.selection === 1) {
            return_slowbro(player)
        }
        if (result.selection === 2) {
            follow_slowbro(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_slowbro(player) {
    player.runCommandAsync("event entity @e [family=slowbro,c=1,r=5] true:to_fight");
}
function return_slowbro(player) {
    player.runCommandAsync("event entity @e [family=slowbro,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:slowbro_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_slowbro(player) {
    player.runCommandAsync("event entity @e [family=slowbro,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//slowbro fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("slowbro_fainted")){
            slowbro_fainted(player)
			player.removeTag("slowbro_fainted")
		}
  }
  function slowbro_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_slowbro_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_slowbro_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:slowbro_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:slowbro_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//slowbro shiny
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("slowbro_s_interact")){
            slowbro_s_interact(player)
			player.removeTag("slowbro_s_interact")
		}
  }
  function slowbro_s_interact (player) {
    const gui = new ActionFormData();
    gui.button('FIGHT!','textures/gui/menu/fight_icon')
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('FOLLOW!', 'textures/gui/menu/follow_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            fight_slowbro_s(player)
        }
        if (result.selection === 1) {
            return_slowbro_s(player)
        }
        if (result.selection === 2) {
            follow_slowbro_s(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function fight_slowbro_s(player) {
    player.runCommandAsync("event entity @e [family=slowbro_s,c=1,r=5] true:to_fight");
}
function return_slowbro_s(player) {
    player.runCommandAsync("event entity @e [family=slowbro_s,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:slowbro_s_item 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function follow_slowbro_s(player) {
    player.runCommandAsync("event entity @e [family=slowbro_s,c=1,r=5] true:to_follow");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//slowbro shiny fainted
system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("slowbro_s_fainted")){
            slowbro_s_fainted(player)
			player.removeTag("slowbro_s_fainted")
		}
  }
  function slowbro_s_fainted (player) {
    const gui = new ActionFormData();
    gui.button('RETURN!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            return_slowbro_s_fainted(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function return_slowbro_s_fainted(player) {
    player.runCommandAsync("event entity @e [type=true:slowbro_s_fainted,c=1,r=5] true:to_return");
    player.runCommandAsync("give @s true:slowbro_s_item_fainted 1");
    player.runCommandAsync("playsound pokemon_return @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//EXPERIENCE CANDY
world.afterEvents.itemUse.subscribe((eventData) => {
const player = eventData.source
const item = player.getComponent('equippable').getEquipment('Mainhand')
        if (item?.typeId == 'true:experience_candy_xs') {
          player.runCommandAsync("xp 5 @s");
          player.runCommandAsync("clear @s true:experience_candy_xs 0 1");
          player.runCommand(`particle minecraft:totem_particle ~ ~ ~`);
        }
        if (item?.typeId == 'true:experience_candy_s') {
          player.runCommandAsync("xp 10 @s");
          player.runCommandAsync("clear @s true:experience_candy_s 0 1");
          player.runCommand(`particle minecraft:totem_particle ~ ~ ~`);
        }
        if (item?.typeId == 'true:experience_candy_m') {
          player.runCommandAsync("xp 20 @s");
          player.runCommandAsync("clear @s true:experience_candy_m 0 1");
          player.runCommand(`particle minecraft:totem_particle ~ ~ ~`);
        }
        if (item?.typeId == 'true:experience_candy_l') {
          player.runCommandAsync("xp 50 @s");
          player.runCommandAsync("clear @s true:experience_candy_l 0 1");
          player.runCommand(`particle minecraft:totem_particle ~ ~ ~`);
        }
        if (item?.typeId == 'true:experience_candy_xl') {
          player.runCommandAsync("xp 100 @s");
          player.runCommandAsync("clear @s true:experience_candy_xl 0 1");
          player.runCommand(`particle minecraft:totem_particle ~ ~ ~`);
        }
     }
 )
 //pokegym bulbasaur
 system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pokegym_bulbasaur")){
            pokegym_bulbasaur(player)
			player.removeTag("pokegym_bulbasaur")
		}
  }
  function pokegym_bulbasaur (player) {
    const gui = new ActionFormData();
    gui.button('START RAID!', 'textures/gui/menu/raid_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            start_raid(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function start_raid(player) {
    player.runCommandAsync("event entity @e [type=true:pokegym,c=1,r=5] true:to_spawn_bulbasaur");
    player.runCommandAsync("playsound pokegym @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
 //pokegym charmander
 system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pokegym_charmander")){
            pokegym_charmander(player)
			player.removeTag("pokegym_charmander")
		}
  }
  function pokegym_charmander (player) {
    const gui = new ActionFormData();
    gui.button('START RAID!', 'textures/gui/menu/raid_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            start_raid(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function start_raid(player) {
    player.runCommandAsync("event entity @e [type=true:pokegym,c=1,r=5] true:to_spawn_charmander");
    player.runCommandAsync("playsound pokegym @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
 //pokegym squirtle
 system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pokegym_squirtle")){
            pokegym_squirtle(player)
			player.removeTag("pokegym_squirtle")
		}
  }
  function pokegym_squirtle (player) {
    const gui = new ActionFormData();
    gui.button('START RAID!', 'textures/gui/menu/raid_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            start_raid(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function start_raid(player) {
    player.runCommandAsync("event entity @e [type=true:pokegym,c=1,r=5] true:to_spawn_squirtle");
    player.runCommandAsync("playsound pokegym @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
 //pokegym abra
 system.runInterval(() =>{
	for(let player of world.getPlayers()){
		if(player.hasTag("pokegym_abra")){
            pokegym_abra(player)
			player.removeTag("pokegym_abra")
		}
  }
  function pokegym_abra (player) {
    const gui = new ActionFormData();
    gui.button('START RAID!', 'textures/gui/menu/raid_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            start_raid(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function start_raid(player) {
    player.runCommandAsync("event entity @e [type=true:pokegym,c=1,r=5] true:to_spawn_abra");
    player.runCommandAsync("playsound pokegym @s ~ ~ ~");
}
function exit(player) {
    player.runCommandAsync;
  }
})
//professor oaks letter
world.afterEvents.itemUse.subscribe((eventData) => {
    const player = eventData.source
    const item = player.getComponent('equippable').getEquipment('Mainhand')
    if (item?.typeId == 'true:professor_oaks_letter') {
        const gui = new ActionFormData();
        gui.body('Choose a Region you would like a Starter Pokemon from!');
        gui.button('Kanto!', 'textures/gui/menu/pokemon/kanto')
        gui.button('Johto!', 'textures/gui/menu/pokemon/johto')
        gui.button('Hoenn!', 'textures/gui/menu/pokemon/hoenn')
        gui.button('Sinnoh!', 'textures/gui/menu/pokemon/sinnoh')
        gui.button('Unova!', 'textures/gui/menu/pokemon/unova')
        gui.button('Exit!', 'textures/gui/menu/exit_icon')
        gui.show(player).then(result => {
            if (result.selection === 0) {
              kanto(player)
            }
            if (result.selection === 1) {
              johto(player)
            }
            if (result.selection === 2) {
              hoenn(player)
            }
            if (result.selection === 3) {
              sinnoh(player)
            }
            if (result.selection === 4) {
              unova(player)
              }
            if (result.selection === 5) {
              exit(player)
            }
         }
      )
   }
   function kanto(player) {
    const gui = new ActionFormData();
    gui.body('Choose your Starter Pokemon!');
    gui.button('Bulbasaur!', 'textures/gui/menu/pokemon/bulbasaur_choose')
    gui.button('Charmander!', 'textures/gui/menu/pokemon/charmander_choose')
    gui.button('Squirtle!', 'textures/gui/menu/pokemon/squirtle_choose')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            bulbasaur_confirm(player)
        }
        if (result.selection === 1) {
            charmander_confirm(player)
        }
        if (result.selection === 2) {
            squirtle_confirm(player)
        }
        if (result.selection === 3) {
            exit(player)
        }
    }
)
}
function bulbasaur_confirm(player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you would like to choose this Pokemon?');
    gui.button('YES!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            bulbasaur_choose(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function bulbasaur_choose(player) {
    player.runCommandAsync("playsound pokemon_celebrate @s ~ ~ ~");
    player.runCommandAsync("give @s true:bulbasaur_item 1");
    player.runCommandAsync("give @s true:poke_ball 10");
    player.runCommandAsync("clear @s true:professor_oaks_letter 0 1");
}
function charmander_confirm(player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you would like to choose this Pokemon?');
    gui.button('YES!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            charmander_choose(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function charmander_choose(player) {
    player.runCommandAsync("playsound pokemon_celebrate @s ~ ~ ~");
    player.runCommandAsync("give @s true:charmander_item 1");
    player.runCommandAsync("give @s true:poke_ball 10");
    player.runCommandAsync("clear @s true:professor_oaks_letter 0 1");
}
function squirtle_confirm(player) {
    const gui = new ActionFormData();
    gui.body('Are you sure you would like to choose this Pokemon?');
    gui.button('YES!', 'textures/gui/menu/return_icon')
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            squirtle_choose(player)
        }
        if (result.selection === 1) {
            exit(player)
        }
    }
)
}
function squirtle_choose(player) {
    player.runCommandAsync("playsound pokemon_celebrate @s ~ ~ ~");
    player.runCommandAsync("give @s true:squirtle_item 1");
    player.runCommandAsync("give @s true:poke_ball 10");
    player.runCommandAsync("clear @s true:professor_oaks_letter 0 1");
}
function johto(player) {
    const gui = new ActionFormData();
    gui.body('Pokemon from this Region are not available yet! Please try again another time!');
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function hoenn(player) {
    const gui = new ActionFormData();
    gui.body('Pokemon from this Region are not available yet! Please try again another time!');
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function sinnoh(player) {
    const gui = new ActionFormData();
    gui.body('Pokemon from this Region are not available yet! Please try again another time!');
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function unova(player) {
    const gui = new ActionFormData();
    gui.body('Pokemon from this Region are not available yet! Please try again another time!');
    gui.button('EXIT!', 'textures/gui/menu/exit_icon')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            exit(player)
        }
    }
)
}
function exit(player) {
    player.runCommandAsync;
     }
   }
  )



